<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Extended Arithmetic>

  They are based on the <samp|gmp> library.

  <\itemize>
    <item>The type <verbatim|ZZ>, alias of the <verbatim|mpz_class>
    corresponds to big integers.\ 

    <item>The type <verbatim|QQ>, alias of <verbatim|mpq_class> corresponds
    to big rational numbers.

    <item>The type <verbatim|RR>, alias of <verbatim|mpf_class> corresponds
    to big floating point numbers.The function <verbatim|Precision> allow the
    user to change the global precision or the precision of a floating point
    number.
  </itemize>

  All these number types are available by including:

  <\quote-env>
    <\code>
      #include \<less\>synaps/arithm/gmp.h\<gtr\>
    </code>
  </quote-env>

  <subsection|Example>

  <\quote-env>
    <\code>
      ZZ a("342453413214531234"), i(1);

      QQ b("334/5");

      RR c("323232442.345345");Precision(34);
    </code>
  </quote-env>

  <subsection|Implementation>

  See: <verbatim|synaps/arithm/gmp.h>

  <subsection|Python module>

  The <name|python> module corresponding to this implementation is named
  <verbatim|arithm>. The type <verbatim|ZZ> is bind to the class
  <verbatim|arithm.Integer>; the type <verbatim|QQ> to
  <verbatim|arithm.Rational>; the type <verbatim|RR> to
  <verbatim|arithm.Float>.

  <with|prog-language|python|prog-session|default|<\session>
    <\input|python] >
      from arithm import *
    </input>

    <\input|python] >
      x=Integer("22333376762");print x
    </input>

    <\output>
      22333376762 : Integer
    </output>

    <\input|python] >
      x*x
    </input>

    <\output>
      \ 498779717593441604644 : Integer
    </output>

    <\input|python] >
      x+=Integer(34545); x*=22344; print x
    </input>

    <\output>
      499017742243608 : Integer
    </output>

    <\input|python] >
      \;
    </input>
  </session>>
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-10|<tuple|1.5.1|?>>
    <associate|auto-11|<tuple|6.1|?>>
    <associate|auto-12|<tuple|6|?>>
    <associate|auto-13|<tuple|6.1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|auto-4|<tuple|1.3|?>>
    <associate|auto-5|<tuple|1.3.1|?>>
    <associate|auto-6|<tuple|1.3|?>>
    <associate|auto-7|<tuple|1.4|?>>
    <associate|auto-8|<tuple|1.4.1|?>>
    <associate|auto-9|<tuple|1.5|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|toc-10|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
    <associate|toc-3|<tuple|<uninit>|?>>
    <associate|toc-4|<tuple|<uninit>|?>>
    <associate|toc-5|<tuple|<uninit>|?>>
    <associate|toc-6|<tuple|<uninit>|?>>
    <associate|toc-7|<tuple|<uninit>|?>>
    <associate|toc-8|<tuple|<uninit>|?>>
    <associate|toc-9|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Extended
      Arithmetic> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>