/********************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 *   $Id: Cst.h,v 1.1 2005/07/11 10:39:47 mourrain Exp $
 ********************************************************************/
#ifndef synaps_arithm_Cst_H
#define synaps_arithm_Cst_H
/********************************************************************/
#include <synaps/init.h>
__BEGIN_NAMESPACE_SYNAPS
/********************************************************************/
/** Handler for scalar types.
No modification of the entries is allowed. This class is used in order 
to avoid temporary objects during arithmetic operations and assignments.
**/
template<class R>
struct CST {
  R  _rep;

  const R & rep() const { return _rep;}
  
  CST() {}
  CST(const R & r): _rep(r){}
  CST(const CST<R> & r): _rep(r._rep){ }

};
//----------------------------------------------------------------------
template<class R> inline
CST<R> Cst (const R & r)   {return CST<R>(r);}
//----------------------------------------------------------------------
template<class R> inline
CST<R> Cst (const CST<R> & r)  {return r;}
//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
/********************************************************************/
#endif //
