/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History: 
$Id: Operator.h,v 1.1 2005/07/11 10:39:47 mourrain Exp $
**********************************************************************/
#ifndef SYNAPS_ARITHM_OPERATOR_H
#define SYNAPS_ARITHM_OPERATOR_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

//----------------------------------------------------------------------
template<char x, class A> struct Op1;
template<char x, class A, class B> struct Op;
//----------------------------------------------------------------------
template <class A> struct Op<'-',A> {
  const A & op;
  Op1 () {};
  Op1 (const Op1<'-',A> &  p): op(p.op) {};
  Op1 (const A & a) : op(a){};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'+',A,B> {
  const A & op1;
  const B & op2;
  Op () {};
  Op(const Op<'+',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'+',A,B> {
  const A & op1;
  const B & op2;
  Op () {};
  Op(const Op<'+',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'-',A,B> {
  const A & op1;
  const B & op2; 
  Op () {};
  Op(const Op<'-',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'*',A,B> {
  const A& op1;
  const B& op2;
  Op() {};
  Op(const Op<'*',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'.',A,B> {
  const A& op1;
  const B& op2;
  Op() {};
  Op(const Op<'.',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'/',A,B> {
  const A& op1;
  const B& op2;
  Op() {};
  Op(const Op<'/',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'%',A,B> {
  const A& op1;
  const B& op2;
  Op() {};
  Op(const Op<'%',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};
//----------------------------------------------------------------------
template <class A, class B> struct Op<'^',A,B> {
  const A& op1;
  const B& op2;
  Op() {};
  Op(const Op<'^',A,B> &  p): op1(p.op1), op2(p.op2) {};
  Op(const A & a, const B & b) : op1(a), op2(b) {};
};


__END_NAMESPACE_SYNAPS

#endif // SYNAPS_ARITHM_OPERATOR_H

