/*******************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 ********************************************************************/
#ifndef synaps_arithm_fct_operator_h
#define synaps_arithm_fct_operator_h
#include <synaps/init.h>
//===================================================================
__BEGIN_NAMESPACE_SYNAPS
//===================================================================
namespace fct {

  template<class U, class A, class B> U add(const A& a, const B& b) { return a+b;}
  template<class U, class A, class B> U sub(const A& a, const B& b) { return a-b;}
  template<class U, class A, class B> U mul(const A& a, const B& b) { return a*b;}
  template<class U, class A, class B> U div(const A& a, const B& b) { return a/b;}
  template<class U, class A, class B> U rem(const A& a, const B& b) { return a%b;}
  template<class U, class A, class B> U pow(const A& a, const B& b) { return a^b;}
  template<class U, class A, class B> U ll(A& a, const B& b)  { return a<<b;}
  template<class U, class A, class B> U gg(const A& a, B& b)  { return a>>b;}

  template<class U, class A> U     get_item1(const A& v, int i)       {return v[i];}
  template<class A, class B> void  set_item1(A& v, int i, const B& x) {v[i]=x;}

  template<class A, class B> A& iadd(A& a, const B& b) { a+=b; return a;}
  template<class A, class B> A& isub(A& a, const B& b) { a-=b; return a;}
  template<class A, class B> A& imul(A& a, const B& b) { a*=b; return a;}
  template<class A, class B> A& idiv(A& a, const B& b) { a/=b; return a;}

  template<class A, class B, class C> A& iaddc(A& a, const B& b) { a+=(C)b; return a;}
  template<class A, class B, class C> A& isubc(A& a, const B& b) { a-=(C)b; return a;}
  template<class A, class B, class C> A& imulc(A& a, const B& b) { a*=(C)b; return a;}
  template<class A, class B, class C> A& idivc(A& a, const B& b) { a/=(C)b; return a;}


  template<class A> int degree1(const A& a) { return degree(a);}
  template<class A> A diff1(const A& a) { return diff(a);}

}
//===================================================================
__END_NAMESPACE_SYNAPS
#endif //
