#ifndef ARITHM_TRAITS_H
#define ARITHM_TRAITS_H

#include <synaps/init.h>
#include <synaps/base/type.h>
#include <synaps/arithm/let.h>
#include <complex>
__BEGIN_NAMESPACE_SYNAPS

#define simple_trait(name,default)\
template< typename X > struct name##_ { typedef default T; };\
template< typename X > struct name { typedef typename name##_< typename type::ucstref<X>::T >::T T; };\

namespace arithm {  using namespace type; };
using namespace arithm;


__END_NAMESPACE_SYNAPS

#include "traits/structureof.h"
#include "traits/kernelof.h"
#include "traits/issubsetof.h"
#include "traits/sup.h"
#include "traits/ringof.h"
#include "traits/fieldof.h"

#include "traits/isring.h"
#include "traits/isfield.h"
#include "traits/isexact.h"

#include "traits/isinteger.h"
#include "traits/isrational.h"
#include "traits/isfloating.h"
#include "traits/isieee.h"

#include "traits/integerof.h"
#include "traits/rationalof.h"
#include "traits/floatingof.h"
#include "traits/ieeeof.h"
#include "traits/realof.h"

#include "traits/hasfunction.h"
#include "traits/hasproperty.h"



 

#endif

