#ifndef SYNAPS_UTIL_DEBUG_UTIL_H
#define SYNAPS_UTIL_DEBUG_UTIL_H

#include <iostream>
#include <string>
#include <synaps/init.h>

//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
#define debug_value(x) std::cout << #x << " = " << x << std::endl
namespace DEBUG {

  inline 
  void print(const std::string& msg)
  {
#if DEBUG_OUTPUT
	std::cout << msg << std::endl;
#endif
	return;
  }

  template < typename T > inline
  void print(const std::string& msg, const T& val)
  {
#if DEBUG_OUTPUT
	std::cout << msg << " = " << val << std::endl;
#endif
	return;
  }


} // END namespace DEBUG
__END_NAMESPACE_SYNAPS
#endif // SYNAPS_UTIL_DEBUG_UTIL_H

