/********************************************************************
 *   This file is part of the source code of the SYNAPS library.
 *   Author(s): J.P. Pavone, GALAAD, INRIA
 *   $Id: chrono.hpp,v 1.1 2005/07/11 10:03:57 jppavone Exp $
 ********************************************************************/
#ifndef SYNAPS_UTIL_CHRONO_H
#define SYNAPS_UTIL_CHRONO_H
//--------------------------------------------------------------------
#include <sys/time.h>
#include <iostream>
#include <synaps/init.h>
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------

#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <synaps/init.h>

#define time()\
({\
  struct timeval t;\
  gettimeofday(&t,NULL);\
  ((double)(t.tv_sec*1000000+t.tv_usec))/((double)1000000);\
})


struct chrono 
{
  bool stopped;
  struct timeval data0;
  struct timeval data1;
  chrono() { stopped = true; };
  inline void start()
  { 
    stopped = false;
    gettimeofday(&data0,0);
  };
  
  inline void stop()
  { 
    gettimeofday(&data1,0);
    stopped = true; 
  };
  unsigned val() {
    //int secs = data1.tv_sec-data0.tv_sec;
    //      int micros = data1.tv_usec - data0.tv_usec;
    return std::abs(data1.tv_sec-data0.tv_sec)*1000000+data1.tv_usec - data0.tv_usec; 
  };
  
    bool ok() {
      int secs = data1.tv_sec-data0.tv_sec;
      return secs> 0;
    };
  
  inline void write( std::ostream& out )
  {
    int micros,secnds,millis,minutes;
    micros  = (data1.tv_sec-data0.tv_sec)*1000000+
	data1.tv_usec - data0.tv_usec;
    secnds  = micros / 1000000;
    micros  = micros % 1000000;
    millis  = micros / 1000;
    micros  = micros % 1000;
    minutes = secnds / 60;
    secnds  = secnds % 60;
      if ( minutes )
	out << 
	  minutes << " mn "; 
      if ( secnds )
	out <<  
	  secnds << " seconds ";
      if ( millis )
	out << 
	  millis << " ms ";
      out << micros << " us \n";
    };
};

//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
/********************************************************************/
#endif //
