/*******************************************************************
 *   This file is part of the source code of the AXEL library.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 *   $Id: $
 ********************************************************************/
#ifndef SYNAPS_VIEWER_WIDTH_H
#define SYNAPS_VIEWER_WIDTH_H
//====================================================================
#include <synaps/init.h>
#include <iostream>
//====================================================================
__BEGIN_NAMESPACE_SYNAPS
struct Width
{
  double sz;
  unsigned nb;
  Width(): sz(0.01), nb(100) {}
  Width(int n): sz(0.01), nb(n){}
  Width(double x): sz(x), nb(100){}
  Width(double x,  unsigned n): sz(x),nb(n){}
  Width(const Width& c): sz(c.sz),nb(c.nb){}
  Width& operator= (const Width & c)
  {
    sz=c.sz; nb=c.nb; return *this;
  }
};

inline std::ostream& operator<<(std::ostream& os, const Width & c)
{
  os <<"Width("<<c.sz<<","<<c.nb<<")"; return os;
}
__END_NAMESPACE_SYNAPS
//====================================================================
#endif 
