#! /usr/bin/perl

while (<ARGV>) {
  # Parameters in text flow
  s{@([^@\n]+)@}|<tt>\1</tt>|g;
  # Comments
  s|/\*{|/\*\*|g;
  s|}\*/|\*/|g;
  s|\*\*/|\*/|g;
  # Code blocks
  s|\\begin{SIGNATURE}|\\code|g;
  s|\\end{SIGNATURE}|\\endcode|g;
  s|\\begin{alltt}|\\code|g;
  s|\\end{alltt}|\\endcode|g;
  s|\\begin{xxx}|\\code|g;
  s|\\end{xxx}|\\endcode|g;
  # Various formatting commands
  s|\\texttt{(.+)}|<tt>\1</tt>|g;
  s|<t>|<tt>|g;
  s|</t>|</tt>|g;
  s|\\ref{(.+)}|\1|g;
  s|{\\tt ([^}\n]+)}|<tt>\1</tt>|g;
  # Formulas
  s|\$([^\$\n]+)\$|\\f\$ \1 \\f\$|g;
  #s|\\(\w)| \\latexonly \mathbf{\1} \\endlatexonly \\htmlonly \1 \\endhtmlonly |g;
  #s|\\y|y|g;
  #s|\\Ac|Ac|g;
  s|\\binomial{([^}\n]+)}{([^}\n]+)}|\\mathbf{binomial}(\1,\2)|g;
  # Latex specific commands
  s|\\index{([^}\n]+)}| \\addindex (\1)\n |g;
  s|(\\cite{.*})| \\latexonly \1 \\endlatexonly |g;
  s|\\dots| \\latexonly \\dots \\endlatexonly \\htmlonly ... \\endhtmlonly |g;
  s|\\help{.+}| |g;
  #s|{\\sc (.+)}| \\latexonly {\\sc \1} \\endlatexonly \\htmlonly \1 \\endhtmlonly |g;
  s|{\\sc ([^}\n]+)}|uc($1)|eg;
  s|__SYNAPS_BEGIN_NAMESPACE||g;
   print $_;

}
