<TeXmacs|1.0.6>

<style|generic>

<\body>
  <section|Using standard data structure>

  The basic data structures of the standard C++ library are available, once
  you have included the correct header files. Many of our constructions will
  be based on such containers.

  If for instance, you want to manipulate lists of say integer, you will use
  the type: <samp|std::list\<less\>int\<gtr\>> which is a parametrised type
  <samp|std::list\<less\>T\<gtr\>> in which we instantiate the type <samp|T>
  by <samp|int>. The <samp|std> prefix is here to speficy that the list
  implementation is from the standard library.

  Let us detail what is going on the following example:

  File: <verbatim|step1-1.cc><hlink||step1-1.cc>

  <\enumerate-numeric>
    <item>As we use the list of the standard library (prefix <samp|std::>)
    and printing functions, we include the header files <samp|iostream> and
    <samp|list>.

    <item>In the main function, we define an abbreviation for the iterators
    on the <samp|list> of <samp|int>.

    <item>We declare l as a <samp|list> of <samp|int> and we append at the
    end of the list, the three elements 1, 2, 3.

    <item>Next, we print it. We use an iterator to scan this list, from the
    beginning <samp|l.begin()> to the end <samp|l.end()>.
  </enumerate-numeric>

  Once you have written this code in a file fich.cc, you can compile it with
  the usual compiler command

  <verbatim|g++ -o step1.ex step1.cc>

  \ and run the executable <samp|step1.ex> or use the command <samp|s++>:\ 

  <verbatim|s++ step1.cc>

  which will also produce the executable <samp|fich.ex>. The result of this
  first execution should look like this:

  <\verbatim>
    ./step1.ex

    1 2 3
  </verbatim>

  If you type directly

  <verbatim|s++ step1.cc -run>\ 

  the file will be compiled and executed. For more information, on the basic
  data structures available in the <samp|STL>, we refer to its reference
  manual.

  <\exercise>
    \ Write a function <samp|sum> which takes as input a list of int and
    outputs the sum of its element.<hlink|<with|mode|math|\<boxdot\>>|step1-exo1.cpp>
  </exercise>

  <\exercise>
    Write a function <samp|apply> which takes as input a list of int and a
    class defining <samp|int opetator()(int a, int b)> (corresponding for
    instance to the addition) and which applies it the elements of the
    list.<hlink|<with|mode|math|\<boxdot\>>|step1-exo2.cpp>
  </exercise>

  Here is an example illustrating the use of generic functions on containers
  \ from some modules such as <samp|VECTOR> (for vectors) or <samp|UPOLDAR>:\ 

  File: <verbatim|step1-2.cc>

  In this example, we use the container <samp|std::vector> instead of
  <samp|std::list>, because it provides a direct access function to the
  <with|mode|math|i<rsup|th>> element. The executation of this programme
  should give:

  <\verbatim>
    [1,2,3]

    (3)*x0^2+(2)*x0+(1) \ 
  </verbatim>

  \;
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Using
      standard data structure> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>