#include <synaps/init.h>
#ifdef SYNAPS_WITH_LAPACK
#include <iostream>
#include "synaps/linalg.h"
#include "synaps/upol.h"       // univariate polynomials

typedef UPolDse<double>    pol_t;
typedef MatrDse<double,lapack::rep2d<double> > matr_t;


matr_t companion(const pol_t & p)
{
  unsigned n= degree(p);
  
  matr_t C(n,n,0.);
  for(unsigned i=0;i<n-1;i++) C(i+1,i)=1;
  for(unsigned i=0;i<n;i++) C(i,n-1)= (-p[i])/p[n];
  
  return C;
  
}

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  pol_t p("2*x^3-34*x+23");                     cout<<p<<endl;

  matr_t C=companion(p);
  cout <<  C <<endl;
  cout <<Eigenval(C)<<endl;
  
}
#else
int main(int argc, char** argv) {}
#endif
