#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include <synaps/arithm/gmp.h>
#include <synaps/upol/UPolDse.h>
#include <synaps/usolve/algebraic/sign_fct.h>
#include <synaps/usolve/Sturm.h>

typedef ALGEBRAIC::root_of<ZZ> algebraic_t;

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  UPolDse<ZZ> p("x^7-2324325131254354*x-1"), q("x^3-2*x-1");
  cout<<p<<endl;
  Seq<algebraic_t> sol = solve(p, Sturm<ZZ>());
  cout<<sol<<endl;
  cout<<sign_at(p,sol[1])<<","<<sign_at(q,sol[1])<<endl;
  
}
#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_GMP
