# synaps miscellaneous functonnnalities


AC_DEFUN([SYNAPS_MISC],
[

AC_ARG_WITH(default,
	    [ --with-default=<path>
					Add <path> to the default path for external package checking
					Set as default with /usr and /usr/local
	    ],
	    [if test "$withval" = yes ; then
			DEFAULT_CHECKING_PATH="/usr /usr/local"
			if test "$with_blas" != no; then
			 with_blas="${DEFAULT_CHECKING_PATH}"
			fi
			if test "$with_lapack" != no; then
			 with_lapack="${DEFAULT_CHECKING_PATH}"
			fi
			if test "$with_mpsolve" != no; then
			 with_mpsolve="${DEFAULT_CHECKING_PATH}"
			fi
			if test "$with_gmp" != no; then
			 with_gmp="${DEFAULT_CHECKING_PATH}"
			fi
			if test "$with_udx" != no; then
			 with_udx="${DEFAULT_CHECKING_PATH}"
			fi
			echo "Default path = ${DEFAULT_CHECKING_PATH}"
	      elif test "$withval" != no ; then
			DEFAULT_CHECKING_PATH="$withval /usr /usr/local";
			prefix=$withval;
			if test "$with_blas" != no; then
			 with_blas="$withval/lib"
			fi
			if test "$with_lapack" != no; then
			 with_lapack="$withval/lib"
			fi
			if test "$with_mpsolve" != no; then
			 with_mpsolve="$withval"
			fi
			if test "$with_gmp" != no; then
			 with_gmp="$withval"
			fi
			if test "$with_udx" != no; then
			 with_udx="$withval"
			fi
			echo "Default path = $withval"
			DEFAULT_CHECKING_PATH="$withval"
	     fi
	     ],
	     [])


AC_ARG_WITH(all,
	    [ --with-all= <path>|yes|no
					Use all external packages.
					If the argument is no, you not sure that all libraries are 
					reachable with the default path.
					Set as default with /usr/local
					If the argument is yes or <empty>, that means that all libraries 
					are reachable with the default path.
					Otherwise add <path> to default path and enable all external packages.
	    ],
	    [if test "$withval" = yes ; then
			check_all="yes"
			DEFAULT_CHECKING_PATH="/usr /usr/local"
			with_blas="${DEFAULT_CHECKING_PATH}"
			with_lapack="${DEFAULT_CHECKING_PATH}"
			with_mpsolve="${DEFAULT_CHECKING_PATH}"
			with_gmp="${DEFAULT_CHECKING_PATH}"
			echo "Checking all external packages in ${DEFAULT_CHECKING_PATH}"

	      elif test "$withval" != no ; then
			check_all="yes"
			with_blas="$withval/lib"
			with_lapack="$withval/lib"
			with_mpsolve="$withval/mpsolve-2.0"
			with_gmp="$withval/gmp-4.1.2"
			DEFAULT_CHECKING_PATH="$withval"
			echo "Checking all external packages in ${DEFAULT_CHECKING_PATH}"

	      elif test "$withval" = no ; then	
			check_all="no"
			with_blas="no"
			with_lapack="no"
			with_mpsolve="no"
			with_gmp="no"
			with_udx="no"
	     fi
	     ],
	     [])

])
