/** \example VectDse.cc **/
#include <synaps/linalg/VectDse.h>
#include <synaps/arithm/gmp.h>

typedef double coeff_t;
typedef VectDse<double> vect_t;
// equivalently typedef VectDse<double,linalg::rep1d<double> >
// VectDse<double> definition based on array1d container, 
// with double coefficients.

using std::cout;
using std::endl;

int main (int argc, char **argv)
{

  VectDse<double> U(4,"0 1 2 3");
    VectDse<double >     V(4,"1 2 3 4");
  VectDse<double >     W(4,"0 1 2 3");
  VectDse<QQ, linalg::rep1d<QQ> > a(3, "1 2 3 4");
  a = 2 * U;
  W = (U*V)*V;
  W = W/3;
  W = (U+V-(U*V)*U/3);
  //  cout << " W = " << W << endl;
  W = -W;
  std::cout << W << std::endl;
  coeff_t tmp;
  let::assign(tmp,(U*V));
  std::cout << tmp << std::endl;
  
  cout << U<<", "<<V<<endl;
  //| U = [0, 2, 1, 3], V = [1, 2, 3, 4] 

  cout<<V*2<<", "<<V/4<<endl;

  //| ([1, 2, 3, 4]).(2), ([1, 2, 3, 4])/(4)
  //| The operations are performed only when the result is assigned to a
  //| variable.


  V /= 2; cout<<V<<endl;

  //| [ 0.5, 1, 1.5, 2 ]

  W=U;U[1]=-1; cout<<W<<", "<<V<<endl;

  //| [0, 2, 1, 3], [0.5, -1,  1.5, 2]

  W= U[Range(1,2)]; cout<<W<<endl;

  //| [-1, 1]

  U[Range(1,2)]= Eval(V[Range(2,3)]); cout<<U<<endl;

  //| [0, 1.5, 2, 3]

}
