#ifndef SYNAPS_LINALG_MATRIXPOL_H
#define SYNAPS_LINALG_MATRIXPOL_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS


namespace MATRIXPOL
{
  template<class MAT> int  degree(const MAT & P);
  template<class MAT, class MatPol> MAT coeffdom(const MatPol & P);
}

template<class MAT> 
int MATRIXPOL::degree(const MAT & M)
{
  typedef typename MAT::size_type size_type;
  
  int d=-1;
  for(size_type i=0; i<M.nbrow(); i++)
    for(size_type j=0; j<M.nbrow(); j++)
      d= max(d,Degree(M(i,j)));
  return d;
}

// template<class MAT, class MatPol>
// MAT MATRIXPOL::coeffdom(const MatPol & P) {
//   MAT N(n,n);int d;
//   for(int j=0; j<n;j++)
//     {
//       d=V[j];
//       for(int i=0; i<n;i++)
//       if (P(i,j).degree()==d)  N(i,j)=P(i,j)[d];
//     }
//   return N;
// }

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_LINALG_MATRIXPOL_H

