/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History: $Id: array1d.C,v 1.1 2005/07/11 08:33:35 mourrain Exp $
**********************************************************************/

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

//OPEN
namespace linalg
{
  template<class C>
  rep1d<C>::rep1d(const rep1d<C> & v) : size_(v.size_){
    //cout <<"xxx"<<endl;
    tab_ = new C[v.size_]; 
    for(size_type i=0;i<v.size_;i++) {tab_[i] = v[i];}
  }

  template<class C>
  rep1d<C>::rep1d(size_type i): size_(i){
    tab_ = new C[i];
    for (size_type i = 0; i < size_; i++) tab_[i]=C(0);
  }
  
template<class C>
rep1d<C>::rep1d(size_type i, C* t)
{
  size_=i;
  tab_ = new C[i];
  for(size_type l=0;l<i;l++) tab_[l] = t[l];
}

  template<class C>
  rep1d<C>::rep1d(C* b, C* e)
{
  size_=0; C* p;
  for(p=b;p!=e;p++,size_++);
  tab_ = new C[size_];
  size_type i=0;
  for(p=b; p!=e; p++,i++) {tab_[i]=(*p);}
}


template<class C>
rep1d<C>::rep1d(size_type l, const char * nm)
{
  std::istringstream ins(nm);
  size_=l;
  tab_ = new C[size_];
  for(size_type i=0; i< size_; i++) ins >>tab_[i];
}
//----------------------------------------------------------------------
template<class C>
void rep1d<C>::resize(const size_type & i)
{
  if(size_!=i){
    if (size_ != 0) {
      C* tmp = tab_;
      tab_ = new C[i];
      for(size_type j=0;j<std::min(i,size_);j++) tab_[j]=tmp[j];
      for(size_type j=std::min(i,size_);j<i;j++) tab_[j]=value_type();
      size_=i;
      delete [] tmp;      
    } else {
      size_=i; tab_= new C[i];
      for(size_type j=0;j<size_;j++) tab_[j]=value_type();
    }
  }
}

template<class C>
rep1d<C> & rep1d<C>::operator=(const rep1d<C> & v) 
{
  if (size_ != v.size_) {
    if (size_ !=0) delete [] tab_;
    tab_ = new C[v.size_];
    size_ = v.size_;
  }
  for(size_type i=0;i<size_;i++) tab_[i] = v[i];
  return *this;
}
//----------------------------------------------------------------------
template<class C> void assign(rep1d<C> & r, const rep1d<C>* t)
{
  if (r.size_ != 0) delete [] r.tab_;
  r.tab_ =t->tab_; 
  r.size_=t->size_;
}
//----------------------------------------------------------------------
template<class C>
typename rep1d<C>::iterator 
  create(typename rep1d<C>::iterator s, const rep1d<C> & a, unsigned int i) 
{
  typedef  typename rep1d<C>::iterator iterator;
  return iterator(&a[i]);
}
//----------------------------------------------------------------------
} //CLOSE linalg

__END_NAMESPACE_SYNAPS

