#ifndef lapack_extern_H
#define lapack_extern_H

#ifdef HAVE_CONFIG_H
#include <synaps/config.h>
#endif

#include "f2c.h"
#ifndef F77NAME
	#ifdef F77_FUNC
		#define F77NAME(x) F77_FUNC(x,x)
	#else
		#define F77NAME(x) x##_
	#endif
#endif

//----------------------------------------------------------------------
extern "C" 
{
  double F77NAME(dlamch)(char * C);

  void F77NAME(dgemm)(char *TRANSA, char *TRANSB, int *M, int *N, int *K, 
		      double *ALPHA, double *A, int *LDA, double *B, 
		      int *LDB, double *BETA, double *C, int *LDC);

  void F77NAME(dgeqpf)(integer *M, integer *N, doublereal *A, integer *lda,
		       integer *jpvt, doublereal *tau, doublereal *work, 
		       integer *info);
  void F77NAME(dgeqrf)(integer *M, integer *N, doublereal *A, integer *lda,
		       doublereal *tau, doublereal *work, integer *lwork,
		       integer *info);

  void F77NAME(dgetrf)(integer *m, integer *n, doublereal *A, integer *lda, 
		       integer *ipiv, integer *info);
  void F77NAME(dgesv) (integer *N, integer *NRHS, doublereal *A, integer *lda,
		       integer *ipiv, doublereal *B, integer *ldb,
		       integer *info);
  void F77NAME(dgelsx)(integer *M, integer *N, integer *NRHS,
		       doublereal *A, integer *lda,doublereal *B, integer *ldb,
		       integer *JPVT, doublereal *RCOND,integer *RANK, 
		       doublereal *WORK, integer *info);
  void F77NAME(dgeev) (char *JOBVL, char *JOVR, integer *N, doublereal *A, 
		       integer *lda, doublereal *WR, doublereal *WI, 
		       doublereal *VL, integer *ldvl, doublereal *VR, 
		       integer *ldvr, doublereal *work, integer *lwork, 
		       integer *info);
  void F77NAME(dgeevx)(char* BALANC, char* JOBVL, char* JOBVR, char* SENSE, 
		       integer* N,  doublereal* A,  integer* LDA,
		       doublereal* WR,  doublereal* WI,  
		       doublereal* VL,  integer* LDVL,  
		       doublereal* VR, integer* LDVR, 
		       integer* ILO, integer* IHI, doublereal* SCALE,  
		       doublereal* ABNRM,  doublereal* RCONDE,   
		       doublereal* RCONDV, doublereal* WORK, 
		       integer* LWORK, integer* IWORK, integer* INFO);
  void F77NAME(dgegv) (char *JOBVL, char *JOVR, integer *N, doublereal *A, 
		       integer *lda, doublereal *B, integer *ldb, 
		       doublereal *WR, doublereal *WI, doublereal *beta, 
		       doublereal *VL, integer *ldvl, doublereal *VR, 
		       integer *ldvr, doublereal *work, integer *lwork, 
		       integer *info);
  void F77NAME(dormqr)(char *SIDE, char *TRANS, integer *M, integer *N, 
		       integer *K, doublereal *A, integer *lda,
		       doublereal *tau, doublereal *C, integer *ldc,
		       doublereal *work, integer *lwork, integer *info);
  void F77NAME(dgesvd)(char *JOBU, char *JOBVT, integer *M, integer *N, 
		       doublereal *A, integer *lda, doublereal *S, 
		       doublereal *U, integer *ldu, doublereal *VT, 
		       integer *ldvt, doublereal *work, integer *lwork, 
		       integer *info);
  void F77NAME(dgeqpf)(integer *M, integer *N, double *A, integer *lda,
		       integer *JPVT, double *TAU, double *work, 
		       integer *info);
  void F77NAME(dtrtri)(char *UPLO,char *DIAG, integer *N, doublereal *A, 
		       integer *lda, integer *info);

  double F77NAME(zlamch)(char * C);

  void F77NAME(zgeqpf)(integer *M, integer *N, doublereal *A, integer *lda,
		       integer *jpvt, doublereal *tau, doublereal *work, 
		       integer *info);
  void F77NAME(zgeqrf)(integer *M, integer *N, doublereal *A, integer *lda,
		       doublereal *tau, doublereal *work, integer *lwork,
		       integer *info);

  void F77NAME(zgetrf)(integer *m, integer *n, doublereal *A, integer *lda, 
		       integer *ipiv, integer *info);
  void F77NAME(zgesv) (integer *N, integer *NRHS, doublereal *A, integer *lda,
		       integer *ipiv, doublereal *B, integer *ldb,
		       integer *info);
  void F77NAME(zgelsx)(integer *M, integer *N, integer *NRHS,
		       doublereal *A, integer *lda,doublereal *B, integer *ldb,
		       integer *JPVT, doublereal *RCOND,integer *RANK, 
		       doublereal *WORK,  doublereal *RWORK, integer *info);
  void F77NAME(zgeev) (char *JOBVL, char *JOVR, integer *N, doublereal *A, 
		       integer *lda, doublereal *WR, doublereal *WI, 
		       doublereal *VL, integer *ldvl, doublereal *VR, 
		       integer *ldvr, doublereal *work, integer *lwork, 
		       integer *info);
  void F77NAME(zgeevx)(char* BALANC, char* JOBVL, char* JOBVR, char* SENSE, 
		       integer* N,  doublereal* A,  integer* LDA,
		       doublereal* WR,  doublereal* WI,  
		       doublereal* VL,  integer* LDVL,  
		       doublereal* VR, integer* LDVR, 
		       integer* ILO, integer* IHI, doublereal* SCALE,  
		       doublereal* ABNRM,  doublereal* RCONDE,   
		       doublereal* RCONDV, doublereal* WORK, 
		       integer* LWORK, integer* IWORK, integer* INFO);
  void F77NAME(zgegv) (char *JOBVL, char *JOVR, integer *N, doublereal *A, 
		       integer *lda, doublereal *B, integer *ldb, 
		       doublereal *WR, doublereal *WI, doublereal *beta, 
		       doublereal *VL, integer *ldvl, doublereal *VR, 
		       integer *ldvr, doublereal *work, integer *lwork, 
		       integer *info);
  void F77NAME(zormqr)(char *SIDE, char *TRANS, integer *M, integer *N, 
		       integer *K, doublereal *A, integer *lda,
		       doublereal *tau, doublereal *C, integer *ldc,
		       doublereal *work, integer *lwork, integer *info);
  void F77NAME(zgesvd)(char *JOBU, char *JOBVT, integer *M, integer *N, 
		       doublereal *A, integer *lda, doublereal *S, 
		       doublereal *U, integer *ldu, doublereal *VT, 
		       integer *ldvt, doublereal *work, integer *lwork, 
		       integer *info);
  void F77NAME(zgeqpf)(integer *M, integer *N, double *A, integer *lda,
		       integer *JPVT, double *TAU, double *work, 
		       integer *info);
  void F77NAME(ztrtri)(char *UPLO,char *DIAG, integer *N, doublereal *A, 
		       integer *lda, integer *info);

}
//----------------------------------------------------------------------
#endif //lapack_extern_H

