
//----------------------------------------------------------------------
extern "C" 
{
  void F77NAME(dsytrf)(char * UPLO, 
		       integer *N, doublereal *A, integer *LDA,
		       integer *IPVT, doublereal *WORK, integer *LWORK,
		       integer *INFO); 
  void F77NAME(dstev)(char * JOBZ, 
		       integer *N, doublereal *D, doublereal *E, doublereal *Z,
		       integer *LDZ, doublereal *WORK, integer *INFO);
  void F77NAME(dsyevd) (char *JOBZ, char *UPLO, integer *N, 
		       doublereal *A, integer *lda,
		       doublereal *W, doublereal *WORK, integer *LWORK,  
		       integer *IWORK, integer* LIWORK, integer *INFO);

}
//----------------------------------------------------------------------

__BEGIN_NAMESPACE_SYNAPS

namespace lapack
{

integer decomp(const LU & lu, sym2d<double> & A)
  {
    // if(IsMatrixEmpty(A))  return;
    
    integer N = A.nbrow(), LDA = A.nbrow();
    integer INFO;
    integer *IPIV  = new integer[N];
    integer LWORK = N*N;
    double *WORK  = new double[LWORK];
  //   if(!work)
  //     Error("%s %s dcmp_QR(int *, COEFF *)\n",ERR_SPACE, ERR_FUNCTION);
    F77NAME(dsytrf)("L",&N, A.tab_, &LDA, IPIV, WORK, &LWORK, &INFO);

    return (INFO);
   
  }; 

//--------------------------------------------------------------------
/** 
  Compute the  real eigenvalues of @A@ and put them in the real
  vector @V@. Use the {\sc lapack} routine @dgeev@.
  The matrix @A@ is copied. 
**/
void eignval(
      linalg::rep1d<double>& V, const sym2d<double> & A, Real)
{
  typedef sym2d<double>::size_type size_type;
  integer  n = A.nbrow(), lda = n;
  integer* info = new integer;
  integer* lwork =new integer(2*n+1); double* work  = new double[*lwork];
  integer* liwork=new integer(1); integer* iwork  = new integer[*liwork];
  
  double* tab= new double[A.size()];
  
  for(unsigned i=0;i<A.size();i++) tab[i]=A[i];
  
  //  double* tev = new double[A.nbcol()*A.nbrow()];
  V.resize(n);
  F77NAME(dsyevd)("N", "U", &n, tab, &lda, V.begin(), 
		  work, lwork, iwork, liwork, info);

  delete [] tab;
  delete [] work;
  delete [] iwork;
}

} // namespace linalg

__END_NAMESPACE_SYNAPS

//--------------------------------------------------------------------
