//#include<vector>

//using namespace std;

__BEGIN_NAMESPACE_SYNAPS

namespace sparse {

template<typename T>
void destroystore(T & m)
{
  typedef typename T::coeff_t C;
  switch (m.Stype)
    {
    case NC:
      {
	for(int i=0;i<((NCformat*)m.Store)->colptr[m.ncol];i++)
	  (((C*)((NCformat*)m.Store)->nzval)+i)->~C();
	  Destroy_CompCol_Matrix(&m);
	break;
      }
    case SC:
      {
	for(int i=0;i<((SCformat*)m.Store)->nzval_colptr[m.ncol];i++)
	  (((C*)((SCformat*)m.Store)->nzval)+i)->~C();
	Destroy_SuperNode_Matrix(&m);
	break;
      }
    case NCP:
      {
	Destroy_CompCol_Permuted(&m);
	break;
      }
    default:
      {
	ABORT("Used Type Storage not yet supported \n");
      }
    };
}
#ifdef QQ
void destroystore(SuperMatrix<Scl<MPQ> >& m)
{
  //cout<<"appel de destroystrore"<<endl;
  switch (m.Stype)
    {
    case NC:
      {
	for(int i=0;i<((NCformat*)m.Store)->colptr[m.ncol];i++)
	  mpq_clear(&((((Scl<MPQ>*)((NCformat*)m.Store)->nzval))[i].rep()));
        Destroy_CompCol_Matrix(&m);
	break;
      }
    case SC:
      {
	for(int i=0;i<((SCformat*)m.Store)->nzval_colptr[m.ncol];i++)
	  mpq_clear(&((((Scl<MPQ>*)((SCformat*)m.Store)->nzval))[i]).rep());
        Destroy_SuperNode_Matrix(&m);
	break;
      }
    case NCP:
      {
	//cout<<"compcol permuted"<<endl;
	Destroy_CompCol_Permuted(&m);
	break;
      }
    default:
      {
	ABORT("Used Type Storage not yet supported \n");
      }
    };
}

void destroystore(SuperMatrix<Scl<MPF> >& m)
{
  // cout<<"appel de destroystrore"<<endl;
  switch (m.Stype)
    {
    case NC:
      {
	for(int i=0;i<((NCformat*)m.Store)->colptr[m.ncol];i++)
	  mpf_clear(&((((Scl<MPF>*)((NCformat*)m.Store)->nzval))[i].rep()));
        Destroy_CompCol_Matrix(&m);
	break;
      }
    case SC:
      {
	for(int i=0;i<((SCformat*)m.Store)->nzval_colptr[m.ncol];i++)
	  mpf_clear(&((((Scl<MPF>*)((SCformat*)m.Store)->nzval))[i]).rep());
        Destroy_SuperNode_Matrix(&m);
	break;
      }
    case NCP:
      {
	//cout<<"compcol permuted"<<endl;
	Destroy_CompCol_Permuted(&m);
	break;
      }
    default:
      {
	ABORT("Used Type Storage not yet supported \n");
      }
    };
}
#endif

template<typename T>
void remiseformatNC(SuperMatrix<T> &M,const std::vector<T> &nzval
		    ,const std::vector<int> &rowind,const std::vector<int> &colptr
		    ,int coeff)
{
  //cout<<"entree dans remiseformat geenric"<<endl;
  destroystore(M);
  M.Stype=NC;
  M.Store=(void *)malloc(sizeof(NCformat));
  NCformat *Mstore=(NCformat *)M.Store;
  Mstore->nnz=nzval.size();
  Mstore->nzval=(void *)malloc(sizeof(T)*(nzval.size()));
  Mstore->rowind=(int*)malloc(sizeof(int)*(nzval.size()));
  Mstore->colptr=(int*)malloc(sizeof(int)*(colptr.size()));
  for(unsigned int i=0;i<nzval.size();++i)
    {
      Mstore->rowind[i]=rowind[i];
      new((T*)(Mstore->nzval)+i) T; 
      ((T*)(Mstore->nzval))[i]=nzval[i];
    }
  for(unsigned int i=0;i<colptr.size();++i)
    Mstore->colptr[i]=colptr[i];
  return;
}
#ifdef QQ
void remiseformatNC(SuperMatrix<Scl<MPQ> > &M,const std::vector<Scl<MPQ> > &nzval
		    ,const std::vector<int> &rowind,const std::vector<int> &colptr
		    ,int coeff)
{
  //cout<<"entree dans remiseformat MPQ"<<endl;
  ((NCformat *)M.Store)->nnz=coeff;
  destroystore(M);
  M.Stype=NC;
  M.Store=(void *)malloc(sizeof(NCformat));
  NCformat *Mstore=(NCformat *)M.Store;
  Mstore->nnz=nzval.size();
  Mstore->nzval=(void *)malloc(sizeof(Scl<MPQ>)*(nzval.size()));
  Mstore->rowind=(int*)malloc(sizeof(int)*(nzval.size()));
  Mstore->colptr=(int*)malloc(sizeof(int)*(colptr.size()));
  for(unsigned int i=0;i<nzval.size();++i)
    {
      Mstore->rowind[i]=rowind[i];
      mpq_init(&((Scl<MPQ>*)(Mstore->nzval))[i].rep());
      ((Scl<MPQ>*)(Mstore->nzval))[i]=nzval[i];
    }
  for(unsigned int i=0;i<colptr.size();++i)
    Mstore->colptr[i]=colptr[i];
  return;
}

void remiseformatNC(SuperMatrix<Scl<MPF> > &M,const std::vector<Scl<MPF> > &nzval
		    ,const std::vector<int> &rowind,const std::vector<int> &colptr
		    ,int coeff)
{
  //cout<<"entree dans remiseformat MPF"<<endl;
  ((NCformat *)M.Store)->nnz=coeff;
  cout<<"destroystore"<<end;
  destroystore(M);
  cout<<"apres destroystore"<<endl;
  M.Stype=NC;
  M.Store=(void *)malloc(sizeof(NCformat));
  NCformat *Mstore=(NCformat *)M.Store;
  Mstore->nnz=nzval.size();
  Mstore->nzval=(void *)malloc(sizeof(Scl<MPF>)*(nzval.size()));
  Mstore->rowind=(int*)malloc(sizeof(int)*(nzval.size()));
  Mstore->colptr=(int*)malloc(sizeof(int)*(colptr.size()));
  for(unsigned int i=0;i<nzval.size();++i)
    {
      Mstore->rowind[i]=rowind[i];
      mpf_init(&((Scl<MPF>*)(Mstore->nzval))[i].rep());
      ((Scl<MPF>*)(Mstore->nzval))[i]=nzval[i];
    }
  for(unsigned int i=0;i<colptr.size();++i)
    Mstore->colptr[i]=colptr[i];
  return;
}
#endif

template<typename T>
void LUConverttoNC(const SuperMatrix<T> & m,
		   SuperMatrix<T> & L,SuperMatrix<T>& U )
{
  int i,j,supernodenumber;//
  SCformat *Lstore=(SCformat*)L.Store;
  NCformat *Ustore=(NCformat*)U.Store;
  //NCformat *newlstore=new NCformat;
  std::vector<T> tmpunzval;//Ustore->nnz);//U NON PLUS N'EST PAS COMPLETE
  std::vector<int> tmpurowind;//Ustore->nnz);//U NON PLUS N'EST PAS COMPLETE
  std::vector<T> tmplnzval;//(Lstore->nnz);
  std::vector<int> tmplrowind;//(Lstore->nnz);
  std::vector<int> tmplcolptr;//(U.ncol);
  std::vector<int> tmpucolptr;//(U.ncol);
  tmpunzval.reserve(Ustore->nnz);
  tmpurowind.reserve(Ustore->nnz);
  tmplnzval.reserve(Lstore->nnz);
  tmplrowind.reserve(Lstore->nnz);
  tmplcolptr.reserve(U.ncol+1);
  tmpucolptr.reserve(U.ncol+1);
  tmplcolptr.push_back(0);
  tmpucolptr.push_back(0);//la premiere colonne de matrice commence au premier nz 
  for(supernodenumber=0;supernodenumber<=Lstore->nsuper;supernodenumber++)
    //Pour chaque supernode
    {
      int upper=1;
      int fsupc=Lstore->sup_to_col[supernodenumber];//colonne de depart 
                                                                                   //du supernodenumber ieme superblock
      int istart=Lstore->rowind_colptr[fsupc];      
      //indice dans rowind qui commence la premiere 
      //colonne  du supernodenumber ieme  supernode
      int nsupr=L_SUB_START(fsupc+1)-istart;
      //nombre d'elements dans la premiere colonne du super
      //node c une constante dans tout le supernode 
      //Cf Def supernode Type2
      for(j=Lstore->sup_to_col[supernodenumber];
	  j < Lstore->sup_to_col[supernodenumber+1];j++,upper++)
	//pour chaque colonne dans le supernode supernodenumber
	{
	  //on traite U en premier
	  T *Ptr=&(((T *)(Lstore->nzval))[L_NZ_START(j)]);
	  //on prend un pointeur sur 
	                                                                                      //le premier element  de la colonne
	  for(i=U_NZ_START(j);i<U_NZ_START(j+1);i++)
	    {
	      tmpunzval.push_back(((T*)(Ustore->nzval))[i]);
	      tmpurowind.push_back(Ustore->rowind[i]);
	    }
	  for(i=0;i<nsupr;i++)
	    {
	      if(Lstore->rowind[istart+i]<(upper+fsupc))
	      {
		tmpunzval.push_back(Ptr[i]);
		tmpurowind.push_back(Lstore->rowind[istart+i]);
	      }
	    }
	  tmpucolptr.push_back(tmpunzval.size());
	  //fin d'extraction de U a partir de L
	  tmplnzval.push_back(1.0);
	  tmplrowind.push_back(fsupc+upper-1);
	  for(i=0;i<nsupr;i++)
	    {
	      if(Lstore->rowind[istart+i]>=(upper+fsupc))
	      {
		tmplnzval.push_back(Ptr[i]);
		tmplrowind.push_back(Lstore->rowind[istart+i]);
	      }
	    }
	  tmplcolptr.push_back(tmplnzval.size());
	  
	}
    }
  //cout<<"tmpunzval.size "<<tmpunzval.size()<<endl;
  //for(typename std::vector<T>::iterator iter=tmpunzval.begin();iter!=tmpunzval.end();iter++)
  // cout<<*iter<<endl;
  //a ce point du programme on a les U et L complets
      // reste a les remettres dans un format qui me plait
  //si on a recupere L depuis SuperLu L n'est pas carre!!
  //on la rerend carre pour le reste du traitement
  for(int i=L.ncol;i<L.nrow;i++)
    {
      tmplnzval.push_back(1);
      tmplrowind.push_back(i);
      tmplcolptr.push_back(tmplcolptr.back()+1);
    }
  //cout<<"remise format NC "<<sp_ienv(6)*((SCformat*)m.Store)->nnz<<endl;
  remiseformatNC(L,tmplnzval,tmplrowind,tmplcolptr,sp_ienv(6)
		 *((SCformat*)m.Store)->nnz);
  L.ncol=L.nrow;
  // ca tranforme les matrices en sortie de super lu 
  //en matrice NCformat que l'on sait bien gerer
  //cout<<"je passe l NCremiseformat"<<endl;
  remiseformatNC(U,tmpunzval,tmpurowind,tmpucolptr,sp_ienv(6)
		 *((SCformat*)m.Store)->nnz);
  //idem
}

}//namespace sparse


__END_NAMESPACE_SYNAPS

