/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History: 
$Id: Plex.h,v 1.1 2005/07/11 11:17:56 mourrain Exp $
**********************************************************************/
#ifndef SYNAPS_MPOL_PLEX_H
#define SYNAPS_MPOL_PLEX_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS


/**
Class specifying the lexicographic order on the monomials of type {\tt M}.
**/
struct Plex
{
  template <class M>
  static bool less (const M &, const M &);
  template <class M>
  bool operator() (const M &, const M &) const {return less(m1,m2);}
};

template <class M>
inline bool Plex::less(const M & m1, const M & m2) {

   int n1 = m1.nvars(), n2 =m2.nvars();
   std::cout<<">> "<<m1<<" "<<n1<<" "<<m2<<" "<<n2<<std::endl;

   int i = max(n1,n2);

   // if(n1 <0 && n2>0) return true;
   // if(n2 <0 && n1>0) return false;

   if(i <0)
     return false;
   else
     {
       while(m1[i] == m2[i] && i>=0) i--;
       return (m1[i]< m2[i]);
     }
}

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_MPOL_PLEX_H

