/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************/
#ifndef SYNAPS_MPOL_Binomial_H
#define SYNAPS_MPOL_Binomial_H
#include <synaps/init.h>
#include <synaps/arithm/pow.h>
#include <synaps/arithm/binomial.h>
//====================================================================
__BEGIN_NAMESPACE_SYNAPS
//====================================================================
/** Expansion of coeff*(x_i+a)^d, where
    i is the index of the variable x,
    a is the shift,
    d is the degree. **/
template < class MP >
MP binomial( typename MP::coeff_t coeff, int i, int d, typename MP::coeff_t a)
{
  MP polynom;
  typename MP::coeff_t tmp;
  for ( int k = 0 ; k <= d ; k++ )
    {
      tmp =  coeff * binomial<typename MP::coeff_t>(d, k) * pow(a,d-k);
      polynom += MP( typename MP::monom_t( tmp , i, k ) );
    }
  return polynom;
}
//====================================================================
__END_NAMESPACE_SYNAPS
//====================================================================
#endif // SYNAPS_MPOL_Binomial_H


