#ifndef MPOL_SQUARE_FREE_HH
#define MPOL_SQUARE_FREE_HH

#include <synaps/mpol/MPol.h>
#include <synaps/upol/square_free.h>
__BEGIN_NAMESPACE_SYNAPS

template<class C, class O, class R>
MPol< C, O, R> square_free ( const MPol<C,O,R> & p )
{
  MPol<C,O,R> result;
  int lv = LastVar(p);
  if ( lv == -1 ) return p;
  convert( result, square_free2( p, lv ), lv );
};

template<class C, class O, class R> 
UPolDse< MPol< C, O, R > > square_free2 ( const MPol< C, O, R > & p , int y = 0 )
{
  typedef MPol<C,O,R>     Polynom;
  typedef UPolDse< Polynom > UPolynom;
  UPolynom f;
  let::convert( f, p, y );
  Polynom c = gcd_coeffs(f);
  Polynom w = f / c;
  c = square_free(c);
  Polynom wy = diff(w,y);
  return (w/gcd(w,wy))*c;
};

__END_NAMESPACE_SYNAPS
#endif
