#define USING_NAMESPACE_SYNAPS 1

#include <list>
#include <iostream>
#include "synaps/mpol/MPol.h"
#include "synaps/mpol/bezoutian.h"
#include "synaps/linalg/VectDse.h"
#include "synaps/linalg/MatrDse.h"

typedef MPol<double> mpol_t;
typedef VectDse<double> vector_t;
typedef MatrDse<double> matrix_t;

int main (int argc, char **argv)
{
  using std::cout;
  using std::cin;
  using std::endl;

  linalg::rep1d<mpol_t> l(3);
  l[0]=mpol_t("x0");
  l[1]=mpol_t("2*x0^2+2*x0*x1+2");
  l[2]=mpol_t("3*x1^2+3*x1+3");

  cout<<"Theta:"<<endl;
  cout <<Theta(l)<<endl;
  matrix_t S=mbezout<matrix_t>(l);
  cout <<"MBezout matrix of size "<<S.nbrow()<<"x"<<S.nbcol()<<endl;
  cout <<S<<endl;
  
}
