#include <synaps/msolve/projection/EigenRes.h>

#ifdef SYNAPS_WITH_LAPACK
using std::cout;
using std::cin;
using std::endl;

typedef MPol<double> mpol_t;

int main(int argc, char **argv)
{

  mpol_t p1("16*x0^4-160*x0^2*x1^2+400*x1^4-32*x0^3+160*x0*x1^2+6*x0^2-50*x1^2+10*x0+1.5625"),
    p2("x0^2-x0*x1+x1^2-1.2*x0-0.0625");
  cout<<"p1="<<p1<<endl;
  cout<<"p2="<<p2<<endl;

  Seq<VectDse<double> > res;
  Seq<int> mux,muy;
  res= solve(p1,p2, EigenRes<double>(1e-3));
  res= solve(p1,p2,mux, EigenRes<double>(1e-6));
  res= solve(p1,p2,mux,muy, EigenRes<double>(1e-7));

  cout<<"Intersection points:"<<endl;
  for(unsigned i=0;i<res.size();++i)
    std::cout<<"("<<res[i][0]<<","<<res[i][1]<<") of multiplicity "<<mux[i]<<" "<<muy[i]<<std::endl;
}
#else
#include <iostream>
int main()
{
  std::cout <<"  LAPACK is not connected"<<std::endl;
  return(77);
}
#endif //SYNAPS_WITH_LAPACK

