#include <synaps/init.h>
#include <synaps/mpol.h>
#include <synaps/base/Seq.h>
#include <synaps/msolve/sbdslv.h>

typedef MPol<double> mpol_t;

int main (int argc, char **argv)
{
  using std::cout; using std::endl;
  
  mpol_t p("x0^2*x1-x0*x1-1"), q("x0^2-x1^3-2");

  std::list<mpol_t> I; I.push_back(p); I.push_back(q);

  VectDse<double> dmn(4,"-2 2 -2 2");
  //  cout << solve(I, SBDSLV<double,SBDSLV_RDL>())<<endl;
  cout << solve(I, SBDSLV<double,SBDSLV_RDL>(1e-3),dmn)<<endl;

  //| [[1.66068,0.911523], [-1.4228,0.290084]
  //
  // The result is a sequence of vectors with coefficients of double type.
  // The size of the vectors is the number of variables.
  // Here there are no solutions in the default [0,1]x[0,1] and
  // 2 real solutions in the box [-2,2]x[-2,2]).

}

