<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Multivariate Bernstein Subdivision solver>

  <\with|par-mode|right>
    <person|J.-P. Pavone>
  </with>

  \;

  We consider here the problem of computing the solutions of a polynomial
  system

  <\equation*>
    <left|{><tabular|<tformat|<table|<row|<cell|f<rsub|1>(x<rsub|1>,\<ldots\>,
    x<rsub|n>)=0>>|<row|<cell|\<vdots\>>>|<row|<cell|f<rsub|s>(x<rsub|1>,\<ldots\>,x<rsub|n>)=0>>>>>
  </equation*>

  in \ a box <with|mode|math|I:=[a<rsub|1>,b<rsub|1>]\<times\>\<cdots\>\<times\>[a<rsub|n>,b<rsub|n>]\<subset\><with|math-font|Bbb*|R><rsup|n>>.
  This solver uses the representation of multivariate polynomials in the
  Bernstein basis, analysis of sign variations and univariate solvers to
  localise the real roots of a polynomial system. The output is a set of
  small-enough boxes, which may contain these roots.

  \;

  By a direct extension to the multivariate case, any polynomial
  <with|mode|math|f(x<rsub|1>,\<ldots\>,x<rsub|n>)\<in\><with|math-font|Bbb*|R>[x<rsub|1>,\<ldots\>,x<rsub|n>]>
  of degree <with|mode|math|d<rsub|i>> in the variable
  <with|mode|math|x<rsub|i>>, can be decomposed as:

  <\equation*>
    f(x<rsub|1>,\<ldots\>,x<rsub|n>)=<big|sum><rsub|i<rsub|1>=0><rsup|d<rsub|1>>\<cdots\><big|sum><rsub|i<rsub|n>=0><rsup|d<rsub|n>>b<rsub|i<rsub|1>,\<ldots\>,i<rsub|n>><space|0.25em>B<rsub|d<rsub|1>><rsup|i<rsub|1>>(x<rsub|1>;a<rsub|1>,b<rsub|1>)\<cdots\>B<rsub|d<rsub|n>><rsup|i<rsub|n>>x(x<rsub|n>;a<rsub|n>,b<rsub|n>).
  </equation*>

  where <with|mode|math|(<space|0.25em>B<rsub|d<rsub|1>><rsup|i<rsub|1>>(x<rsub|1>;a<rsub|1>,b<rsub|1>)\<cdots\>B<rsub|d<rsub|n>><rsup|i<rsub|n>>(x<rsub|n>;a<rsub|n>,b<rsub|n>))<rsub|0\<le\>i<rsub|1>\<le\>d<rsub|1>,\<ldots\>,0\<le\>i<rsub|n>\<le\>d<rsub|n>>>
  is the tensor product Bernstein basis on the domain
  <with|mode|math|I:=[a<rsub|1>,b<rsub|1>]\<times\>\<cdots\>\<times\>[a<rsub|n>,b<rsub|n>]\<subset\><with|math-font|Bbb*|R><rsup|n>>
  and <with|mode|math|<with|math-font-series|bold|b>=(b<rsub|i<rsub|1>,\<ldots\>,i<rsub|n>>)<rsub|0\<le\>i<rsub|1>\<le\>d<rsub|1>,\<ldots\>,0\<le\>i<rsub|n>\<le\>d<rsub|n>>>
  are the control coefficients of <with|mode|math|f> on <with|mode|math|I>.
  The polynomial <with|mode|math|f> is represented in this basis by the
  <with|mode|math|n<rsup|<with|mode|text|font-family|rm|th>>> order tensor of
  control coefficients <with|mode|math|<with|math-font-series|bold|b>=(b<rsub|i<rsub|1>,\<ldots\>,i<rsub|n>>)<rsub|0\<le\>i\<le\>d<rsub|1>,0\<le\>j\<le\>d<rsub|2>,0\<le\>k\<le\>d<rsub|3>>>.
  The size of <with|mode|math|I>, denoted by <with|mode|math|\|I\|>, is
  <with|mode|math|\|I\|=max {\|b<rsub|i>-a<rsub|i>\|;i=1,\<ldots\>,n}>.

  De Casteljau algorithm also applies in each of the direction
  <with|mode|math|x<rsub|i>>, , <with|mode|math|i=1,\<ldots\>,n> so that we
  can split this representation in these directions. We use the following
  properties to isolate the roots:

  <\definition>
    For any <with|mode|math|f\<in\><with|math-font|Bbb*|R>[<with|math-font-family|bf|x>]>
    and <with|mode|math|j=1,\<ldots\>,n>, let

    <\eqnarray*>
      <tformat|<table|<row|<cell|m<rsub|j>(f;x<rsub|j>)>|<cell|=>|<cell|<big|sum><rsub|i<rsub|j>=0><rsup|d<rsub|j>>min<rsub|{0\<le\>i<rsub|k>\<le\>d<rsub|k>,k\<neq\>j}>b<rsub|i<rsub|1>,\<ldots\>,i<rsub|n>><space|0.25em>B<rsup|i<rsub|j>><rsub|d<rsub|j>>(x<rsub|j>;a<rsub|j>,b<rsub|j>)>>|<row|<cell|M<rsub|j>(f;x<rsub|j>)>|<cell|=>|<cell|<big|sum><rsub|i<rsub|j>=0><rsup|d<rsub|j>>max<rsub|{0\<le\>i<rsub|k>\<le\>d<rsub|k>,k\<neq\>j}>b<rsub|i<rsub|1>,\<ldots\>,i<rsub|n>>x<space|0.25em>B<rsup|i<rsub|j>><rsub|d<rsub|j>>(x<rsub|j>;a<rsub|j>,b<rsub|j>).>>>>
    </eqnarray*>
  </definition>

  <\theorem>
    [Projection Lemma]<label|polenvellop>For any
    <with|mode|math|<with|math-font-series|bold|u>=(u<rsub|1>,\<ldots\>,u<rsub|n>)\<in\>I>,
    and any <with|mode|math|j=1,\<ldots\>,n>, we have

    <\equation*>
      m(f;u<rsub|j>)\<le\>f(<with|math-font-series|bold|u>)\<le\>M(f;u<rsub|j>).
    </equation*>
  </theorem>

  As a direct consequence, we obtain the following corollary:

  <\corollary>
    <label|correduction>For any root <with|mode|math|<with|math-font-series|bold|u>=(u<rsub|1>,\<ldots\>,u<rsub|n>)>
    of the equation <with|mode|math|f(<with|math-font-series|bold|x>)=0> in
    the domain <with|mode|math|I>, we have
    <with|mode|math|<underline|\<mu\>><rsub|j>\<le\>u<rsub|j>\<le\><overline|\<mu\>><rsub|j>>
    where

    <\itemize>
      <item><with|mode|math|<underline|\<mu\>><rsub|j>> (resp.
      <with|mode|math|<overline|\<mu\>><rsub|j>>) is either a root of
      <with|mode|math|m<rsub|j>(f;x<rsub|j>)=0> or
      <with|mode|math|M<rsub|j>(f;x<rsub|j>)=0> in
      <with|mode|math|[a<rsub|j>,b<rsub|j>]> or <with|mode|math|a<rsub|j>>
      (resp. <with|mode|math|b<rsub|j>>) if
      <with|mode|math|m<rsub|j>(f;x<rsub|j>)=0> (resp.
      <with|mode|math|M<rsub|j>(f;x<rsub|j>)=0>) has no root on
      <with|mode|math|[a<rsub|j>,b<rsub|j>]>,

      <item><with|mode|math|m<rsub|j>(f;u)\<le\>0\<le\>M<rsub|j>(f;u)> on
      <with|mode|math|[<underline|\<mu\>><rsub|j>,<overline|\<mu\>><rsub|j>]>.
    </itemize>
  </corollary>

  The solver implementation contains the following main steps. It consists in\ 

  <\itemize>
    <item*|1>applying a preconditioning step on the equations;

    <item*|2>in reducing the domain;

    <item*|3>if the reduction ratio is too small, to split the domain
  </itemize>

  until the size of the domain is smaller than a given epsilon.

  As we are going to see, we have several options for each of these steps,
  leading to different algorithms with different behaviors, as we will see in
  the next sections. Indeed the solvers that we will consider are
  parameterized by the

  <\itemize-minus>
    <item><with|font-series|bold|Preconditioner>: A transformation of the
    initial system into a system, which has a better numerical behavior.

    <item><with|font-series|bold|Reduction strategy>: The technique used to
    reduce the initial domain, for searching the roots of the system.

    <item><with|font-series|bold|Subdivision strategy>: The technique used to
    subdivide the domain, in order to simplify the forthcoming steps, for
    searching of roots of the system.
  </itemize-minus>

  <paragraph|Preconditioners.> Solving the system
  <with|mode|math|<with|math-font-series|bold|f>=0> is equivalent to solving
  the system <with|mode|math|M<space|0.25em><with|math-font-series|bold|f>=0>,
  where <with|mode|math|M> is an <with|mode|math|s\<times\>s> invertible
  matrix

  As such a transformation may increase the degree of some equations, with
  respect to some variables, it has a cost, which might not be negligible in
  some cases.

  Moreover, if for each polynomials of the system not all the variables are
  involved, that is if the systems is sparse with respect to the variables,
  such a preconditioner may transform it into a system which is not sparse
  anymore. In this case, we would prefer a partial preconditioner on a
  subsets of the equations sharing a subset of variables.\ 

  The following preconditioners are curently avialable:

  <\itemize-dot>
    <item><with|font-series|bold|Global transformation:> We minimise the
    distance between the equations, considered as vectors in an affine space
    of polynomials of a given degree.

    <item><with|font-series|bold|Local straightening:> In this part we
    consider square systems, for which <with|mode|math|s=n>.

    If we are ``near'' a simple solution of the system
    <with|mode|math|<with|math-font-series|bold|f>=0>, we transform locally
    the system <with|mode|math|math-font-series|bold|f> into a system
    <with|mode|math|J<rsup|-1><with|math-font-series|bold|f>>, where
    <with|mode|math|J=(\<partial\><rsub|x<rsub|i>>f<rsub|j>(<with|math-font-series|bold|u><rsub|0>)<rsub|1\<le\>i,j\<le\>s>>
    is the Jacobian matrix of <with|mode|math|math-font-series|bold|f> at a
    point <with|mode|math|math-font-series|bold|u> of the domain
    <with|mode|math|I>, where it is invertible. A direct computation shows
    that locally (in a neighborhood of <with|mode|math|<with|math-font-series|bold|u><rsub|0>>
    the level-set of <with|mode|math|f<rsub|i>>
    <with|mode|math|i=1,\<ldots\>,s> are orthogonal to the
    <with|mode|math|x<rsub|i>>-axes: This transformation was also discussed
    in <cite|gs-isbaspe-01>. We can prove that the reduction based on the
    polynomial bounds <with|mode|math|m> and <with|mode|math|M> behaves like
    Newton iteration near a simple root, that is we have a quadratic
    convergence.
  </itemize-dot>

  <paragraph|Reduction strategy.> Here are several reduction strategies,,
  that can be considered.

  <\itemize>
    <item><with|font-series|bold|Convex hull reduction>: In
    <cite|sp-csnps-93>, a method called Interval Projected Polyhedron (or
    IPP) is described, in order to reduce the domain of search. It is based
    on the property that the convex hull property. A new reduced domain is
    computed, by intersecting the convex hull of the projected set of control
    points. With our notations, in considering the control polygons defining
    <with|mode|math|m<rsub|j>(f<rsub|k>;u<rsub|j>)> and
    <with|mode|math|M<rsub|j>(f<rsub|k>,u<rsub|j>)> instead of these
    polynomials.

    <item><with|font-series|bold|Extreme root reduction>: A direct
    improvement of the convex hull reduction consist in computing the first
    (resp. last) root of the polynomial <with|mode|math|m<rsub|j>(f<rsub|k>;u<rsub|j>)>,
    (resp. <with|mode|math|M<rsub|j>(f<rsub|k>;u<rsub|j>)>), in the interval
    <with|mode|math|[a<rsub|j>,b<rsub|j>]>. The current implementation of
    this reduction steps allows us to consider the convex hull reduction, as
    one iteration step of this reduction process.

    <item><with|font-series|bold|Univariate solver reduction> Here, we
    compute all the roots of the polynomials
    <with|mode|math|m<rsub|j>(f<rsub|k>;u<rsub|j>)> and
    <with|mode|math|M<rsub|j>(f<rsub|k>;u<rsub|j>)> and keep the intervals
    <with|mode|math|[<underline|\<mu\>>,<overline|\<mu\>>]> defined in
    corollary <reference|correduction>.

    The guarantee that the computed intervals contain the root of
    <with|mode|math|f>, is achieved by controlling the rounding mode of the
    operations during the de Casteljau computation.

    This method will be particularly interesting in the cases where more than
    one interval have to be considered. This may happen at the beginning of
    the search but is less expected locally near a single root.
  </itemize>

  <paragraph|Subdivision strategy.>Here some simple rules that can be used to
  subdivide a domain. We will show in the next section their impact on the
  performance of the solver

  <\itemize>
    <item><with|font-series|bold|Parameter bisection>: The domain
    <with|mode|math|I> is then split in half in a direction
    <with|mode|math|j> for which <with|mode|math|\|b<rsub|j>-a<rsub|j>\|> is
    maximal.

    <item><with|font-series|bold|Image bisection>: Instead of choosing the
    size of the interval as a criterion for the direction in which we split,
    we may choose a <with|mode|math|j> and a <with|mode|math|k> such that
    <with|mode|math|\<delta\><rsub|j>(f<rsub|k>;u<rsub|j>)=M<rsub|j>(f<rsub|k>;u<rsub|j>)-m<rsub|j>(f<rsub|k>;u<rsub|k>)>
    (or the difference between the control coefficients) is maximal. Then, a
    value <with|mode|math|u<rsub|j>> for splitting the domain in the
    direction <with|mode|math|x<rsub|j>>, is chosen

    <\itemize>
      <item>either where <with|mode|math|\<delta\><rsub|j>(f<rsub|k>;u<rsub|j>)>
      has a local maximum,

      <item>or where

      <\equation>
        <big|int><rsub|v=0><rsup|u>\<delta\><rsub|j>(f<rsub|k>;v)d*v=<frac|1|2><big|int><rsub|v=0><rsup|1>\<delta\><rsub|j>(f<rsub|k>;v)d*v
      </equation>

      The right-hand side of this equation can be easily computed, from the
      sum of all the control coefficients of
      <with|mode|math|\<delta\><rsub|j>(f<rsub|k>;v)>.
    </itemize>
  </itemize>

  <subsection|Implementation details>

  See <verbatim|synaps/msolve/sbdslv.h>.

  <subsection|Example>

  <action|<with|mode|math|\<boxdot\>>|MSubdivision.cc>
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-10|<tuple|2.3|?>>
    <associate|auto-2|<tuple|1|?>>
    <associate|auto-3|<tuple|2|?>>
    <associate|auto-4|<tuple|3|?>>
    <associate|auto-5|<tuple|1.1|?>>
    <associate|auto-6|<tuple|1.2|?>>
    <associate|auto-7|<tuple|4|?>>
    <associate|auto-8|<tuple|2.1|?>>
    <associate|auto-9|<tuple|2.2|?>>
    <associate|castel|<tuple|1|?>>
    <associate|correduction|<tuple|3|?>>
    <associate|footnote-1|<tuple|1|?>>
    <associate|footnote-2|<tuple|2|?>>
    <associate|footnote-3|<tuple|3|?>>
    <associate|polenvellop|<tuple|2|?>>
    <associate|thnf|<tuple|1|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.1.1|?>>
    <associate|valpr|<tuple|2|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|bib>
      gs-isbaspe-01

      sp-csnps-93
    </associate>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Multivariate
      Bernstein Subdivision solver> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|6fn>|Preconditioners.
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.15fn>>

      <with|par-left|<quote|6fn>|Reduction strategy.
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3><vspace|0.15fn>>

      <with|par-left|<quote|6fn>|Subdivision strategy.
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4><vspace|0.15fn>>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Implementation details
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>
    </associate>
  </collection>
</auxiliary>