<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Multivariate normal form solver>

  <\with|par-mode|right>
    <name|Ph. Trebuchet>
  </with>

  We consider here the problem of computing the solutions of a system

  <\equation*>
    <left|{><tabular|<tformat|<table|<row|<cell|f<rsub|1>(x<rsub|1>,\<ldots\>,
    x<rsub|n>)=0>>|<row|<cell|\<vdots\>>>|<row|<cell|f<rsub|s>(x<rsub|1>,\<ldots\>,x<rsub|n>)=0>>>>>
  </equation*>

  in the case where such a system has a finite number of solutions in
  <with|mode|math|\<bbb-C\><rsup|n>>. The method developped in <cite|PhT02>
  is implemented here. It proceeds in two steps

  <\itemize>
    <item>Computation of the generalised normal form modulo the ideal
    <with|mode|math|(f<rsub|1>,\<ldots\>, f<rsub|n>)>.

    <item>Computation of the roots from eigencomputation.
  </itemize>

  The stopping criterion for these generalized normal forms
  <with|mode|math|N> is the following:

  \;

  <\theorem>
    <label|thnf>Let <with|mode|math|B> be a vector space in
    <with|mode|math|R=<with|math-font|Bbb*|R>[x<rsub|1>,\<ldots\>,x<rsub|n>]>
    connected to the constant polynomial <with|mode|math|1> <footnote|Any
    monomial <with|mode|math|<with|math-font-series|bold|x><rsup|\<alpha\>>\<neq\>1\<in\>B>
    is of the form <with|mode|math|x<rsub|i><with|math-font-series|bold|x><rsup|\<beta\>>>
    with <with|mode|math|<with|math-font-series|bold|x><rsup|\<beta\>>\<in\>B>
    and some <with|mode|math|i> in <with|mode|math|{1,\<ldots\>,n}>.>. If
    <with|mode|math|B<rsup|+>> is the vector subspace generated by
    <with|mode|math|B\<cup\>x<rsub|1><space|0.25em>B\<cup\>\<ldots\>\<cup\>x<rsub|n><space|0.25em>B>,
    <with|mode|math|N:B<rsup|+>\<rightarrow\>B> is a linear map such that
    <with|mode|math|N> is the identity on <with|mode|math|B>, we define for
    <with|mode|math|i=1,\<ldots\>,n,> the maps

    <\eqnarray*>
      <tformat|<table|<row|<cell|M<rsub|i>:B>|<cell|\<rightarrow\>>|<cell|B>>|<row|<cell|b>|<cell|\<mapsto\>>|<cell|M<rsub|i>(b):=N(x<rsub|i>b).>>>>
    </eqnarray*>

    The two following properties are equivalent:

    <\enumerate>
      <item>For all <with|mode|math|1\<leq\>i,j\<leq\>n>,
      <with|mode|math|M<rsub|i>\<circ\>M<rsub|j>=M<rsub|j>\<circ\>M<rsub|i>>.

      <item><with|mode|math|R=B\<oplus\>I>, where <with|mode|math|I> is the
      ideal generated by the kernel of <with|mode|math|N>
    </enumerate>

    If this holds, the <with|mode|math|B>-reduction along <with|mode|math|ker
    (N)> is canonical.
  </theorem>

  From this normal form <with|mode|math|N>, we deduce the roots of the system
  as follows. We use the properties of the operators of multiplication by
  elements of <with|mode|math|<with|math-font|cal|A>=R/(f<rsub|1>,..,f<rsub|s>))>.
  For any <with|mode|math|a\<in\><with|math-font|cal|A>>, we define

  <\eqnarray*>
    <tformat|<table|<row|<cell|M<rsub|a>:\<cal-A\>>|<cell|\<rightarrow\>
    >|<cell|\<cal-A\>>>|<row|<cell|b >|<cell|\<mapsto\>>|<cell|M<rsub|a>(b)\<equiv\>
    a b>>>>
  </eqnarray*>

  We also consider its transpose operator

  <\eqnarray*>
    <tformat|<table|<row|<cell|M<rsub|a><rsup|t>:<wide|<with|math-font|cal|A>|^>>|<cell|\<rightarrow\>
    >|<cell|<wide|<with|math-font|cal|A>|^>>>|<row|<cell|\<Lambda\>
    >|<cell|\<mapsto\>>|<cell|M<rsub|a>(\<Lambda\>)\<equiv\> \<Lambda\>
    \<circ\> M<rsub|a> >>>>
  </eqnarray*>

  The matrix of <with|mode|math|M<rsub|a><rsup|<with|math-font-family|tt|t>>>
  in the dual basis of a basis <with|mode|math|B> of
  <with|mode|math|math-font|cal|A> is the transpose of the matrix of
  <with|mode|math|M<rsub|a>> in <with|mode|math|B>.

  Our approach to solve polynomial systems is based on the following
  fundamental theorem:

  <\theorem>
    <cite|AuSt88><label|valpr> <cite|BMr98>Assume that
    <with|mode|math|<with|math-font|cal|Z>(I)={\<zeta\><rsub|1>,\<ldots\>,\<zeta\><rsub|d>}>.
    We have

    <\enumerate>
      <item>Let <with|mode|math|a\<in\><with|math-font|cal|A>>. The
      eigenvalues of the operator <with|mode|math|M<rsub|a>> (and its
      transpose <with|mode|math|M<rsup|<with|math-font-family|tt|t>><rsub|a>>)
      are <with|mode|math|a(\<zeta\><rsub|1>),\<ldots\>,a(\<zeta\><rsub|d>)>.

      <item>The common eigenvectors of <with|mode|math|(M<rsup|<with|math-font-family|tt|t>><rsub|a>)<rsub|a\<in\><with|math-font|cal|A>>>
      are (up to a scalar) <with|mode|math|<with|math-font-family|bf|1><rsub|\<zeta\><rsub|1>>,\<ldots\>,<with|math-font-family|bf|1><rsub|\<zeta\><rsub|d>>>.
    </enumerate>
  </theorem>

  Since <with|mode|math|<with|math-font-series|bold|x><rsup|E>=(<with|math-font-series|bold|x><rsup|\<alpha\>>)<rsub|\<alpha\>\<in\>E>>
  is a basis of <with|mode|math|math-font|cal|A>, the coordinates of
  <with|mode|math|<with|math-font-family|bf|1><rsub|\<zeta\><rsub|i>>> in the
  dual basis of <with|mode|math|<with|math-font-series|bold|x><rsup|E>> are
  <with|mode|math|(\<zeta\><rsub|i><rsup|\<alpha\>>)<rsub|\<alpha\>\<in\>E>>.
  Thus if <with|mode|math|<with|math-font-series|bold|x><rsup|E>> contains
  <with|mode|math|1,x<rsub|1>,\<ldots\>,x<rsub|n>> (which is often the case),
  we deduce the following algorithm:

  <paragraph|Algorithm: ><with|font-shape|small-caps|Solving zero-dimensional
  system (case of simple roots)>

  Let <with|mode|math|a\<in\><with|math-font|cal|A>> such that
  <with|mode|math|a(\<zeta\><rsub|i>)\<neq\>a(\<zeta\><rsub|j>)> if
  <with|mode|math|i\<neq\>j> (which is generically the case) and
  <with|mode|math|M<rsub|a>> be the multiplication matrix by
  <with|mode|math|a> in the basis <with|mode|math|<with|math-font-series|bold|x><rsup|E>=(1,x<rsub|1>,\<ldots\>,x<rsub|n>,\<ldots\>)>
  of <with|mode|math|math-font|cal|A>.

  <\enumerate-numeric>
    <item>Compute the eigenvectors <with|mode|math|\<Lambda\>=(\<Lambda\><rsub|1>,\<Lambda\><rsub|x<rsub|1>>,\<ldots\>,\<Lambda\><rsub|x<rsub|n>>,\<ldots\>)>
    of <with|mode|math|M<rsub|a><rsup|t>>.

    <item>For each eigenvector <with|mode|math|\<Lambda\>> with
    <with|mode|math|\<Lambda\><rsub|1>\<neq\>0>, compute and return the point
    <with|mode|math|\<zeta\>=(<frac|\<Lambda\><rsub|x<rsub|1>>|\<Lambda\><rsub|1>>,\<ldots\>,<frac|\<Lambda\><rsub|x<rsub|n>>|\<Lambda\><rsub|1>>)>.
  </enumerate-numeric>

  The case of multiple roots is treated similarly, by applying a strategy
  similar the one described in <cite|CGT97>. \ For more details on the
  algorithm, see <cite|mt:gnfpss-issac-05>.\ 

  <subsection|Implementation>

  The function which implements all these steps is:

  <\code>
    template\<less\>class C\<gtr\>\ 

    \ \ \ Seq\<less\>VectDse\<less\>std::complex\<less\>double\<gtr\> \<gtr\>
    \<gtr\> solve(L,Newmac\<less\>C\<gtr\>);
  </code>

  where\ 

  <\itemize-dot>
    <item><verbatim|C> is the type of coefficient in which we want to compute
    the normal form,

    <item>L is the sequence of polynomials to solve.
  </itemize-dot>

  See <verbatim|synaps/msolve/Newmac.h>.

  <subsection|Example>

  <action|<with|mode|math|\<boxdot\>>|Newmac.cc>
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-10|<tuple|2.3|?>>
    <associate|auto-2|<tuple|1|?>>
    <associate|auto-3|<tuple|1.1|?>>
    <associate|auto-4|<tuple|1.2|?>>
    <associate|auto-5|<tuple|1.3|?>>
    <associate|auto-6|<tuple|3|?>>
    <associate|auto-7|<tuple|4|?>>
    <associate|auto-8|<tuple|2.1|?>>
    <associate|auto-9|<tuple|2.2|?>>
    <associate|castel|<tuple|1|?>>
    <associate|correduction|<tuple|5|?>>
    <associate|footnote-1|<tuple|1|?>>
    <associate|footnote-2|<tuple|2|?>>
    <associate|footnote-3|<tuple|3|?>>
    <associate|polenvellop|<tuple|4|?>>
    <associate|thnf|<tuple|1|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.1.1|?>>
    <associate|valpr|<tuple|2|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|bib>
      PhT02

      AuSt88

      BMr98

      CGT97

      mt:gnfpss-04
    </associate>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Multivariate
      normal form solver> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|6fn>|Algorithm:
      \ <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.15fn>>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>
    </associate>
  </collection>
</auxiliary>