#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include <synaps/mpol.h>
#include <synaps/base/Seq.h>
#include <synaps/arithm/gmp.h>
#include <synaps/msolve/Newmac.h>

typedef MPol<RR> mpol_t;

int main (int argc, char **argv)
{
  using namespace std;

  mpol_t p("x0^2*x1-x0*x1-1"), q("x0^2-x1^3-1");

  std::list<mpol_t> I; I.push_back(p); I.push_back(q);

  cout << Solve(I, Newmac<RR>())<<endl;

  //| [ (0.421134,0.779225) (-1.15111,0.166259) ]
  //| [ (0.421134,-0.779225) (-1.15111,-0.166259) ]
  //| [ (1.24525,-0.588209) (-0.0526987,1.13817) ]
  //| [ (-0.424222,0.478962) (0.405487,0.957865) ]
  //| [ (1.24525,0.588209) (-0.0526987,-1.13817) ]
  //| [ (-0.424222,-0.478962) (0.405487,-0.957865) ]
  //| [ (1.5648,3.86247e-19) (1.13148,8.13152e-19) ]
  //| [ (-1.04912,-1.30962e-18) (0.465166,-1.41031e-19) ]

  // The result is a dense matrix of coefficients of type 
  // complex<double>. The columns correspond to the coordinates 
  // of the roots (here x0, x1). The rows correspond to the roots 
  // of the system (here 8 roots, with 2 which are real).
}
#else
#include <iostream>
int main()
{
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
}
#endif //SYNAPS_WITH_GMP

