
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS

//#define SEUIL 1e-10
double SEUIL=1e-10;
#define PHTABS(x) ((x>(typcoeff)0)?x:(typcoeff)(-1)*x)

#if 1
#ifdef SYNAPS_WITH_GMP
int Iszero(const QQ &c)
   {
      return c==(int)0;
    }
#endif //SYNAPS_WITH_GMP
#endif

template<typename typcoeff>
int Iszero(const typcoeff & c)
{
  int res=0;
  if(PHTABS(c)<(typcoeff)SEUIL)
    res=1;
  return res;
}

template<typename pol>
int Ispolzero(const pol & p)
{
  int res=1;
  for(int i=0;i<p.size;i++)
    if (!Iszero(p.nf[i])) {res=0;break;}
  return res;
}

template<typename typP>
//cf corealgo ligne 310
void selectnozero(typP & ttmp)
{
  typedef typename typP::value_type polyalp;
  typP res;
  for(typename typP::iterator iterttmp=ttmp.begin();iterttmp!=ttmp.end();iterttmp++)
    {
      int yes=0;
      for(typename polyalp::iterator iter=iterttmp->begin();
	  iter!=iterttmp->end();iter++)
	if(!Iszero(iter->coeff())) yes=1;
      if (yes)
      {
	      res.push_back(*iterttmp);
      //	      cout<<"un polnome non zero "<<endl<<*iterttmp<<endl;
      }
    }
  ttmp.swap(res);
  return;
}
//#undef SEUIL
#undef PHTABS


__END_NAMESPACE_SYNAPS

