#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<typename T> 
void MAC_REV_FREE(void *,int);

template<typename T>
void INIT_ELEM(void * ptr, int size)
{
  for(unsigned i=0;i<(size/(sizeof(T)));i++)
    new((T*)ptr+i) T;
}
template<typename T>
void CLEAR_ELEM(void * ptr, int size)
{
  for(unsigned int i=0;i<size/(sizeof(T));i++)
    ((T*)ptr+i)->~T();
}

template<typename T>
inline void * MAC_REV_MALLOC(int size)
{
  void * res;
  res=malloc(size);
  INIT_ELEM<T>(res,size);
  return res;
}

template<typename T>
inline void * MAC_REV_REALLOC(void * ptr,int size,int newsize)
{
  void *res=ptr;
  if(size<newsize)
    {
      res=realloc(ptr,newsize);
      INIT_ELEM<T>((char*)res+size,newsize-size);
    }
  if(size>newsize)
    {
      CLEAR_ELEM<T>((char*)ptr+newsize,size-newsize);
      res=realloc(ptr,newsize);
    }
  return res;
}
template<typename T>
inline void MAC_REV_FREE(void * ptr,int size)
{
  if(size>0)
    CLEAR_ELEM<T>(ptr,size);
  free(ptr);
}
/*
template<>
void INIT_ELEM<Mon>(void *ptr,int size)
{
  typedef Mon::coeff_t coeff;
  int tmp=size/sizeof(Mon);
  for(int i=0;i<tmp;i++)
    INIT_ELEM<coeff>(&(((Mon*)ptr+i)->coeff),sizeof(coeff));
}

template<>
void CLEAR_ELEM<mon>(void *ptr,int size)
{
  typedef mon::coeff_t coeff;
  int tmp=size/sizeof(mon);
  for(int i=0;i<tmp;i++)
    CLEAR_ELEM<coeff>(&(((mon*)ptr)+i)->coeff,sizeof(coeff));
}*/


__END_NAMESPACE_SYNAPS


