#ifndef SYNAPS_SHAPE_GEOMVIEW_STREAM_HPP
#define SYNAPS_SHAPE_GEOMVIEW_STREAM_HPP

#include <stdio.h>
#include <assert.h>
#include <synaps/init.h>

__BEGIN_NAMESPACE_AXEL

namespace gmv
{
  void swab4( unsigned *, unsigned );
  void swab4( unsigned *, unsigned *, unsigned );
  struct stream
  {
    FILE * m_fd;
    float  m_lcolor  [4];
    bool   m_binary;
    //float  m_matcolor[4];
    stream( const char * fname, bool binary = true );
    ~stream();
    void flush();
    void line_color( float * color );
    inline void matcolor( float * color )
    { fprintf(m_fd,"appearance {\n material{\n diffuse %f %f %f\n}\n}\n",color[0],color[1],color[2]); };

    void polyline( float * src, int nv, float * colors = 0, int nc = 1 );
    void uvsmp ( float * src, unsigned m, unsigned n, float * colors = 0 );
    void quads ( float * src, unsigned nq, float * colors = 0 );
    void points( float * src, unsigned nv );
    void sphere( float * p, float r );
    void ellipse( float * prms ); // incomplet
    void spheres( float * centers, float r, unsigned n, float * color = 0, int dice = 2 );
    void graph( float * z, unsigned m, unsigned n, float * colors = 0 );
    //    void thickpolyline( float * pts, unsigned n, float thickness );
    void stick( float * pts, unsigned m, float thick );
  };
}

__END_NAMESPACE_AXEL  

#endif
