#ifndef GMV_CMD_HPP
#define GMV_CMD_HPP
#include <stdlib.h>
#include <unistd.h>
#include <utils/strings.hpp>
#include <sys/types.h>
namespace gmv
{

  void ppm_run( char * gmvfile, const char * ppmfile, float * backcolor, int m, int n, float thickness = 3  )
  {
    pid_t pid = fork();
    if ( pid == 0 )
      {
	char * PWD = getenv("PWD");
	//    if ( !GMV ) { std::cout << "GMV_PATH environement variable undefined !\n"; exit(1);};
	char szTmp[1000];
	sprintf(szTmp,"%s/%s",PWD,ppmfile);
	std::cout << std::endl;
	{
	  std::ofstream gclstream("/tmp/cmd.gcl");
	  gclstream << "(load \"" << gmvfile << "\")\n";
	  gclstream << "(new-camera  \"cam\" )\n" << std::endl;
	  gclstream << "(backcolor \"cam\" " << backcolor[0] << " " 
		    << backcolor[1] << " " << backcolor[2]  << " )\n";
	  gclstream << "(bbox-draw \"" << utils::bgnom(gmvfile) << "\" no)\n";
	  gclstream << "(merge-ap " << utils::bgnom(gmvfile) <<  " { linewidth " 
		    << thickness << " } )\n";
	  gclstream << "(snapshot \"cam\" \"" << szTmp << "\" \"ppm\" " 
		    << m << " " << n << ")\n";
	  gclstream << "(exit)\n";
	};
	//    char * etmerde = strdup( "-c /tmp/cmd.gcl" );
	char  * const prm[] = { "geomview", "/tmp/cmd.gcl", 0 };
	//    free( etmerde);
	execvp("geomview", prm);
      };
  };
  
  void gvx_run( char * gmvfile, float * backcolor, float * matcolor, float thickness = 3, 
		float polygonoffset = 1e-3  )
  {
    pid_t pid = fork();
    if ( pid == 0 )
      {
	char * PWD = getenv("PWD");
	//    if ( !GMV ) { std::cout << "GMV_PATH environement variable undefined !\n"; exit(1);};
	//      char szTmp[1000];
	//	sprintf(szTmp,"%s/%s",PWD,ppmfile);
	std::cout << std::endl;
	{
	  std::ofstream gclstream("/tmp/cmd.gcl");
	  gclstream << "(load \"" << gmvfile << "\")\n";
	  gclstream << "(new-camera  \"cam\" )\n" << std::endl;
	  gclstream << "(backcolor \"cam\" " << backcolor[0] << " " 
		    << backcolor[1] << " " << backcolor[2]  << " )\n";
	  gclstream << "(bbox-draw \"" << utils::bgnom(gmvfile) << "\" no)\n";
	  gclstream << "(merge-ap " << utils::bgnom(gmvfile) <<  " { linewidth " 
		    << thickness << " } )\n";
	  gclstream << "(merge-ap " << utils::bgnom(gmvfile) << " { shading smooth } )\n";
	  //	  gclstream << "(merge-ap " << utils::bgnom(gmvfile) << " lighting { light { color 1 1 1 \n position  0 0 .5 1 \n location camera } })\n";
	  gclstream << "(merge-ap " << utils::bgnom(gmvfile) << 
	    " material { diffuse " << matcolor[0] << " " << matcolor[1] << " " << matcolor[2] << "})\n";
	  gclstream << "(merge-ap " << utils::bgnom(gmvfile) << 
	    " material { backdiffuse " << matcolor[0] << " " << matcolor[1] << " " << matcolor[2] << "})\n";
	  //	  gclstream << "(lines-closer \"cam\"" << polygonoffset << ")\n";
	  
	  
	  //gclstream << "(exit)\n";
	};
	//    char * etmerde = strdup( "-c /tmp/cmd.gcl" );
	char  * const prm[] = { "geomview", "/tmp/cmd.gcl", 0 };
	//    free( etmerde);
	execvp("geomview", prm);
      };
  };
};
#endif
