#ifndef SYNAPS_SHAPE_IMPLICITSURFACE_H
#define SYNAPS_SHAPE_IMPLICITSURFACE_H

#include <synaps/shape/interfaces/IShape.h>
#include <synaps/shape/gmv/stream.h>

__BEGIN_NAMESPACE_SYNAPS

struct IImplicitSurface : IShape
{
  typedef IShape base_t;
  void setDomain  ( const double coords[6] ) ;
  void getDomain  ( double coords[6] ) const ;
  void eval( double * r, const double * p, int n ) const ;
};

struct IAlgebraicSurface : IImplicitSurface
{
  typedef IImplicitSurface base_t;
  virtual void setEquation( const char * eq ) = 0;
  virtual std::string getEquation() const = 0; 
};

__END_NAMESPACE_SYNAPS

#endif
