#ifndef TREES_BNODE_H
#define TREES_BNODE_H
#include <iostream>
#include <vector>
namespace trees
{
  struct  bnode 
  {
    bnode * m_l; bnode * m_r; bnode():m_l(0),m_r(0) {}; 
    template<typename T>
    inline void setsons( T * l, T * r ) { m_l = (bnode*)l; m_r = (bnode*)r; };
    inline bool isleaf() const {  return m_l ==  m_r; };
  };
  struct fbnode : bnode { fbnode * m_f; };

  template< typename node > inline node const * const left( node const * const n )   { return (node*)((bnode*)n)->m_l; };
  template< typename node > inline node *& left( node * n ) { return (node*&)((bnode*)n)->m_l; };
  
  template< typename node > inline node const * const right( node const * const n )  { return (node*)((bnode*)n)->m_r; };
  template< typename node > inline node *& right( node * n ) { return (node*&)((bnode*)n)->m_r; };

  template< typename node > inline node const * const father( node const * const n ) { return (node*)((bnode*)n)->m_l; };
  template< typename node > inline node *& father( node * n ) { return (node*)((bnode*)n)->m_l; };
  
  int  depth ( bnode * n );
  void leaves( std::vector< bnode* >& lvs, bnode * n );
  template< typename node >
  void leaves( std::vector< node* >& lvs, node * n )
  { leaves( *(std::vector< bnode*>*)(&lvs), (bnode*)n ); };
};
#endif
