#include <synaps/shape/gaia/gaia.h>
#include <synaps/shape/gaia/sample.h>

__BEGIN_NAMESPACE_SYNAPS

namespace gaia
{
  sample::sample( const IParametricSurface * s, int m, int n )
  {
    double _st = time();
    m_psurf = s;
    m_uvals = new double[3*m*n+m+n];
    m_vvals = m_uvals + m;
    m_svals = (fxv<double,3>*)(m_vvals + n);
    m_nrows = m;
    m_ncols = n;
    s->sample((double*)m_svals,m_uvals,m_vvals,m,n);
    std::cout << "s = " << (time()-_st) << std::endl;
  };
  sample::~sample() { delete[] m_uvals; };
};
__END_NAMESPACE_SYNAPS  

