#include <synaps/shape/gmv/stream.h>
#include <algorithm>
__BEGIN_NAMESPACE_SYNAPS
namespace gmv
{
  void stream::polyline( const float * src, int nv, float * colors, int nc )
  {
    if ( colors == 0 ) { colors = m_lcolor;; nc = 1; };
    assert(nc==1||nc==nv);
    assert(sizeof(unsigned)==sizeof(float));
    assert(sizeof(unsigned)==4);
    
    if ( 0) //m_binary )
      {
	fprintf(m_fd,"{ = VECT BINARY\n");
	//    1,nv,nc,nv,nc,3*nv,4*nc;
	unsigned sz = (5+3*nv+4*nc);
	unsigned * chnk = new unsigned[ sz ];
	unsigned * data = chnk;
	data[0] = 1; data[1] = nv; data[2] = nc;
	data[3] = nv; data[4] = nc;
	float * points = (float*)(data + 5);
	std::copy(src,src+3*nv,points);
	float * rgbas = (float*)(points + 3*nv);
	std::copy(colors,colors+4*nc,rgbas);
	swab4(data,sz);
	fwrite(data,4,sz,m_fd);
	fprintf(m_fd,"}\n");
	delete[] data;
      }
    else
      {
	fprintf(m_fd,"{ = VECT\n");
	fprintf(m_fd,"%i %i %i\n", 1, nv, nc);
	fprintf(m_fd,"%i\n", nv);
	fprintf(m_fd,"%i\n", nc);
	for ( int i = 0; i < nv; i++, src += 3 )
	  fprintf(m_fd,"%f %f %f\n", src[0], src[1], src[2] );
	for ( int i = 0; i < nc; i++ )
	  fprintf(m_fd,"%f %f %f %f\n",colors[i*4],colors[i*4+1],colors[i*4+2],colors[i*4+3]);
	fprintf(m_fd,"}\n");
      };
  };
__END_NAMESPACE_SYNAPS
};
