#include <iostream>
#include <synaps/base/type.h>


struct Shape
{
  typedef type::null_t Base;
  virtual std::string representation() = 0;
};

struct Surface
{
  typedef Shape Base;
  virtual void draw() = 0;
};

struct ParametricSurface
{
  typedef Surface Base;
  virtual void eval() = 0;
};

struct BSplineSurface 
{
  typedef ParametricSurface Base;
  virtual void split() = 0;
};

template<class R>
void eval( const ParametricSurface & s, const R & r, 
	   const double * uv, int n )
{
};

template<class R>
void foo( const ParametricSurface &, const R & r )
{
  std::cout << " foo::ParametricSurface \n";
};

/*
template<class R> 
void foo( const BSplineSurface & a, const R & r )
{
  std::cout << " foo::BSplineSurface \n";
};
*/

namespace Function
{
template<class R>
void foo( const R & r )
{
  foo( r, r );
};

template<class R>
void eval( const R & r )
{
  foo( r, r );
};

template<class R>
void draw( const R & r )
{
  foo(r,r);
};
template<class R> 
void split( const R & r )
{
  foo(r,r);
};
};


template<class R,class Y> struct wrap;

#define REP(Name,View) struct Name : wrap<Name,View>

template<class R, class X> struct wrap {};
#define WRAPPER(Name)\
template<class R>\
struct wrap<R,Name> : Name, wrap<R,typename Name::Base>\

WRAPPER(Shape)
{
  const char *  shape_repname;
  std::string  representation() { return type::name<R>(); };
};

WRAPPER(Surface) 
{ 
  void draw() { Function::draw(*(const R*)this); };
};

WRAPPER(ParametricSurface) 
{ 
  void eval() {  Function::eval(*(const R*)this); }; 
};

WRAPPER(BSplineSurface)
{
  void split() { Function::split(*(const R*)this); };
};





REP(MaBSplineQuiTue,BSplineSurface) 
{
  
};

void print_representation( Shape * s )
{
  std::cout << s->representation() << std::endl;
};

void eval( ParametricSurface * s )
{
  s->eval();
};

int main()
{
  MaBSplineQuiTue tmp;

  std::cout << type::name<int>() << std::endl;
  print_representation(&tmp);
  eval(&tmp);
};
