/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S1324

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
void
s1324(double ecentr[],double aradiu,double enorm[],int idim,
	   double carray[],int *jstat)
#else
void s1324(ecentr,aradiu,enorm,idim,carray,jstat)
     double ecentr[];
     double aradiu;
     double enorm[];
     int    idim;
     double carray[];
     int    *jstat;
#endif
{
  int kdimp1;         
  int kdimp2;         
  int kstop;          
  int ki;             
  int kpos=0;         
  int kstat;          
  
  
  
  
  if (idim != 3) goto err104;
  
  kdimp1 = idim + 1;
  kdimp2 = idim + 2;
  kstop  = 2*kdimp1*kdimp1;
  
  for (ki=0;ki<kstop;ki++)
    {
      carray[ki] = (double)0.0;
    }
  
  
  
  s1322(ecentr,enorm,aradiu,idim,1,carray,&kstat);
  if (kstat<0) goto error;
  
  
  
  
  carray[28] = enorm[0];
  carray[29] = enorm[1];
  carray[30] = enorm[2];
  
  
  
  carray[31] = -s6scpr(enorm,ecentr,idim);
  
  *jstat = 0;
  goto out;
  
  
 err104: *jstat = -104;
  s6err("s1324",*jstat,kpos);
  goto out;
  
  
 error: *jstat = kstat;
  goto out;
  
  
 out:
  return;
}

