/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S1381

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
void 
s1381(double et[],int in,int ik,double **gt,int *jkn,int jkk,int *jstat)           
#else
void s1381(et,in,ik,gt,jkn,jkk,jstat)
     double et[];
     int    in;
     int    ik;
     double **gt;
     int    *jkn;
     int    jkk;
     int    *jstat;           
#endif
                                                               
{                                                                     
  double tval;     
  double *sdum;    
  int ki,kl;       
  int knumb;       
  int kstop;       
  int kpos=0;      
  
  
  knumb = 0;       
  tval = et[ik-1];
  
  for (ki=ik ; ki<=in ; ki++)
    {
      if (tval < et[ki])
        {
	  
	  knumb = knumb + 1;
	  tval = et[ki];
        }
    }
  
  *jkn = (jkk-1)*(knumb-1) + jkk;
  
  sdum = newarray(*jkn+jkk,DOUBLE);
  if (sdum == SISL_NULL) goto err101;
  
  *gt  = sdum; 
  
  
  
  tval = et[ik-1];
  
  
  
  for (kl=0;kl<jkk;kl++)
    {        
      sdum[kl] = tval;
    }
  
  
  
  for (ki=ik ; ki<=in ; ki++)
    {
      if (tval < et[ki])
        {
	  
	  tval = et[ki];
	  kstop = kl + jkk-1;
	  for (;kl<kstop;kl++)
            sdum[kl] = tval;
        }   
    }
  
  
  
  sdum[kl] = tval;
  
  *jstat = 0;
  goto out;
  
  
 err101: *jstat = -101;
  s6err("s1381",*jstat,kpos);
  goto out;
 out:
  
  return;
}                                               

