/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S1399

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
void 
s1399(SISLCurve *pc,double astart,double astop)
#else
void s1399(pc,astart,astop)
     SISLCurve  *pc;
     double astart;
     double astop;
#endif
{
  int  kk= pc->ik;             
  int  kn= pc->in;             
  double *st=SISL_NULL;              
  double a,b;
  int ii, kpos=0, kstat=0;
  if (!pc) goto out;
  
  if((st = newarray(kk+kn,DOUBLE)) == SISL_NULL) goto err101;
  
  a = pc -> et[kk-1];
  b = pc -> et[kn];
  
  for (ii=0;ii<kn+kk;ii++)
    st[ii] = astart+(((pc -> et[ii])-a)/(b-a))*(astop-astart);
  for (ii=0;ii<kn+kk;ii++)
    pc -> et[ii] = st[ii];
  goto out;
  
  
  
  err101: 
    kstat = -101;
    s6err("s1399",kstat,kpos);
    goto out;
      
  out:
    if (st != SISL_NULL) freearray(st);
    return;
}

