/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S2515

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
void
   s2515(SISLSurf *surf, int ider, int iside1, int iside2, double parvalue[],
      int *leftknot1,int *leftknot2, double mehlum[], int *stat)
#else
 void s2515(surf, ider, iside1, iside2, parvalue, leftknot1, leftknot2, 
	    mehlum, stat)
      SISLSurf *surf;
      int    ider;
      int    iside1;
      int    iside2;
      double parvalue[];
      int *leftknot1;
      int *leftknot2;
      double mehlum[];
      int *stat;
#endif
{
   double derive[18];     
   double normal[3];      
      
      
   if (ider != 0) goto err178;
      
   if (surf == SISL_NULL)  goto err150;
   else
   {
	 
      
	 
      s1422(surf,2,iside1,iside2,parvalue,leftknot1,leftknot2,derive,normal,
	    stat);
      if (*stat < 0)       
         goto error;
      else if (*stat != 2) 
      {
	 s2516(surf, ider, derive, normal, mehlum, stat);
	 if (*stat < 0) goto error;
      }
      else if (*stat == 2) 
	 goto out;
	 
   }
      
   
      
   goto out;

   
 err150:
   *stat = -150;
   s6err("s2515", *stat, 0);
   goto out;
      
   
 err178:
   *stat = -178;
   s6err("s2515", *stat, 0);
   goto out;
   
         
 error:
   s6err("s2515",*stat,0);
   goto out;
      
 out:
	 
   return;
      
}

