/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define SH1460

#include "sislP.h"


typedef void (*fshapeProc)(
#if defined(SISLNEEDPROTOTYPES)
                           double [],
  			   double [],
                           int,
                           int,
                           int *
#endif
);

typedef  void (*fevalmidProc)(
#if defined(SISLNEEDPROTOTYPES)
                              fshapeProc,
                              SISLCurve *[],
                              int,
                              double [],
                              double [],
                              double [],
                              int *
#endif
);

#if defined(SISLNEEDPROTOTYPES)
void sh1460(fshapeProc fshape,SISLCurve *vboundc[],int icurv,
	    SISLSurf ***wsurf,int *jstat)
#else
void sh1460(fshape,vboundc,icurv,wsurf,jstat)
     fshapeProc fshape;
     SISLCurve  *vboundc[];
     int        icurv;
     SISLSurf   ***wsurf;
     int        *jstat;
#endif
{
  int kstat = 0;         
  int kpos = 0;          

  

  fevalmidProc fevalmid;
  

  *wsurf = SISL_NULL;
  if ((*wsurf = newarray(icurv,SISLSurf*)) == SISL_NULL) goto err101;

  

  if (icurv == 3)
    {
      

      fevalmid = sh1462;
      sh1461(fshape,fevalmid,vboundc,icurv,*wsurf,&kstat);
      if (kstat < 0) goto error;
    }
  else if (icurv == 4)
    {
      

       fevalmid = sh1463 ;
       sh1461(fshape,fevalmid,vboundc,icurv,*wsurf,&kstat);
       if (kstat < 0) goto error;
    }
  else if (icurv == 5)
    {
      

      fevalmid = sh1464;
      sh1461(fshape,fevalmid,vboundc,icurv,*wsurf,&kstat);
      if (kstat < 0) goto error;
    }
  else if (icurv == 6)
    {
      

      fevalmid = sh1465;
      sh1461(fshape,fevalmid,vboundc,icurv,*wsurf,&kstat);
      if (kstat < 0) goto error;
    }
  else
    {
      

      goto err105;
    }

  

  *jstat = 0;
  goto out;

  

  err101:
    *jstat = -101;
    s6err("sh1460",*jstat,kpos);
    goto out;

  

  err105 :
    *jstat = -105;
    s6err("sh1460",*jstat,kpos);
    goto out;

  

  error :
    *jstat = kstat;
    s6err("sh1460",*jstat,kpos);
    goto out;

  out :
    return;
}

