/** \example TopSweep2d.cc **/

#include <cstdio>
#include <synaps/arithm/gmp.h>
#include <synaps/topology/TopSweep2d.h>

int main(int argc, char** argv) 
{
  const char * exemples[] = { 
    "33481-68244*x+47684*y+32162*x^2-54873*x*y+86*x^3*y+2566*x^3+3974*y^4*x+1354*x^2*y^3+13464*y^3-14150*y^4+4622*y^5+37086*y^2*x+7078*x^2*y-6980*y^3*x+204*x^2*y^2+34*x^4+267*x^3*y^2+x^5-y^7-21*x*y^5+25*x^4*y-30*y^6-37557*y^2",
    "x^6+y^2*x^4-y^4*x^2-2*x^4-y^6+2*y^4+x^2-y^2+x*y"
  };
  for ( int i = 0; i < 2; i ++ )
    {
      std::cout << i << std::endl;
      MPol<QQ> p(exemples[i], Variables("x y"));
      topology::point_graph<double> g;
      topology::assign(g, p, TopSweep2d<double>());
      char file[200];
      sprintf(file,"tmp-%i.off",i);
      geomview::ostream vw(file);
      vw<<g;
      vw.view();
    };
  return 0;
  
}
