<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Sylvester and Bezout matrices>

  <subsection|The compagnon matrix>

  <label| compagnon>Let <with|mode|math|\<bbb-K\>> be any field and suppose
  given a polynomial <with|mode|math|f(x):=f<rsub|d>x<rsup|d>+f<rsub|d-1>x<rsup|d-1>+\<cdots\>+f<rsub|1>x+f<rsub|0>>
  in <with|mode|math|\<bbb-K\>[x]>. Using the standard Euclidean polynomial
  division it is easy to see that the quotient algebra
  <with|mode|math|<with|math-font|cal|A>=<with|math-font|Bbb|K>[x]/I>, where
  <with|mode|math|I> denotes the principal ideal of
  <with|mode|math|\<bbb-K\>[x]> generated by the polynomial
  <with|mode|math|f(x)>, is a vector space over <with|mode|math|\<bbb-K\>> of
  dimension <with|mode|math|d> with canonical basis
  <with|mode|math|{1,x,\<ldots\>,x<rsup|d-1>}.>

  Consider the multiplication by <with|mode|math|x> in
  <with|mode|math|math-font|cal|A,> <with|mode|math|M<rsub|x>:<with|math-font|cal|A>\<to\><with|math-font|cal|A>>
  defined by <with|mode|math|a\<mapsto\>a<space|0.25spc>x.> It is
  straightforward to check that the matrix of <with|mode|math|M<rsub|x>> in
  the basis <with|mode|math|{1,x,\<ldots\>,x<rsup|d-1>}> is given by

  <\equation*>
    M<rsub|x>=<left|[><tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|c>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|-1|3|3|cell-halign|c>|<cwith|1|-1|4|4|cell-halign|c>|<table|<row|<cell|0>|<cell|\<cdots\>>|<cell|0>|<cell|-f<rsub|0>/f<rsub|d>>>|<row|<cell|1>|<cell|\<ddots\>>|<cell|>|<cell|\<vdots\>>>|<row|<cell|\<vdots\>>|<cell|>|<cell|0>|<cell|\<vdots\>>>|<row|<cell|0>|<cell|>|<cell|1>|<cell|-f<rsub|d-1>/f<rsub|d>>>>>><right|]>
  </equation*>

  (the column on the far right corresponds to the Euclidean division of
  <with|mode|math|x<rsup|d>> by <with|mode|math|f>). Therefore the
  characteristic polynomial of <with|mode|math|M<rsub|x>> equals
  <with|mode|math|<frac|(-1)<rsup|d>|f<rsub|d>>f(x)> and the roots, with
  their corresponding multiplicities, of the polynomial <with|mode|math|f>
  can be recovered by computing the eigenvalues of the multiplication map
  <with|mode|math|M<rsub|x>>. See e.g. <cite|Lang02>.

  \;

  See: <verbatim|synaps/upol/resultant.h>

  <subsection|The sylvester matrix>

  Let <with|mode|math|A> be a commutative ring, which is assumed to be a
  domain, and suppose given two polynomials in <with|mode|math|A[x]> of
  respective degree <with|mode|math|d<rsub|0>> and <with|mode|math|d<rsub|1>>

  <\equation*>
    <tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|l>|<table|<row|<cell|f<rsub|0>(x):=c<rsub|0,0>+c<rsub|0,1>x+\<cdots\>+c<rsub|0,d<rsub|0>>x<rsup|d<rsub|0>>,>>|<row|<cell|f<rsub|1>(x):=c<rsub|1,0>+c<rsub|1,1>x+\<cdots\>+c<rsub|1,d<rsub|1>>x<rsup|d<rsub|1>>.>>>>>
  </equation*>

  \;

  The Sylvester matrix of <with|mode|math|f<rsub|0>> and
  <with|mode|math|f<rsub|1>> (in degree <with|mode|math|(d<rsub|0>,d<rsub|1>)>)
  is the matrix whose columns contain respectively the coefficients of the
  polynomials <with|mode|math|f<rsub|0>,x*f<rsub|0>,\<ldots\>,x<rsup|d<rsub|1>-1>f<rsub|0>.>
  <with|mode|math|f<rsub|1>,x*f<rsub|1>,\<ldots\>,<space|0.25spc>x<rsup|d<rsub|0>-1>f<rsub|1>>
  expanded in the monomial basis <with|mode|math|{1,x,\<ldots\>,x<rsup|d<rsub|0>+d<rsub|1>-1>}>.
  It is a square matrix of size <with|mode|math|d<rsub|0>+d<rsub|1>> which
  has the following form:

  <\equation*>
    S=<tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|2|cell-halign|l>|<table|<row|<cell|<left|(><tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|c>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|-1|3|3|cell-halign|c>|<cwith|1|-1|3|3|cell-rborder|1ln>|<cwith|1|-1|4|4|cell-halign|c>|<cwith|1|-1|5|5|cell-halign|c>|<cwith|1|-1|6|6|cell-halign|c>|<table|<row|<cell|c<rsub|0,0>>|<cell|>|<cell|0>|<cell|c<rsub|1,0>>|<cell|>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|\<ddots\>>|<cell|>|<cell|\<vdots\>>|<cell|\<ddots\>>|<cell|>>|<row|<cell|>|<cell|>|<cell|c<rsub|0,0>>|<cell|>|<cell|>|<cell|c<rsub|1,0>>>|<row|<cell|c<rsub|0,d<rsub|0>>>|<cell|>|<cell|\<vdots\>>|<cell|c<rsub|1,d<rsub|1>>>|<cell|>|<cell|\<vdots\>>>|<row|<cell|>|<cell|\<ddots\>>|<cell|\<vdots\>>|<cell|>|<cell|\<ddots\>>|<cell|\<vdots\>>>|<row|<cell|0>|<cell|>|<cell|c<rsub|0,d<rsub|0>>>|<cell|0>|<cell|>|<cell|c<rsub|1,d<rsub|1>>>>>>><right|)>>|<cell|<tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|l>|<table|<row|<cell|1>>|<row|<cell|x>>|<row|<cell|\<vdots\>>>|<row|<cell|\<vdots\>>>|<row|<cell|\<vdots\>>>|<row|<cell|x<rsup|d<rsub|0>+d<rsub|1>-1>>>>>>>>>>>
  </equation*>

  More precisely, it is the matrix of the <with|mode|math|A>-linear map

  <\equation>
    <label|phi><tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<cwith|1|-1|2|2|cell-halign|r>|<cwith|1|-1|3|3|cell-halign|l>|<table|<row|<cell|\<sigma\>:A[x]<rsub|\<less\>d<rsub|1>>\<oplus\>A[x]<rsub|\<less\>d<rsub|0>>>|<cell|\<rightarrow\>>|<cell|A[x]<rsub|\<less\>d<rsub|0>+d<rsub|1>>>>|<row|<cell|(q<rsub|0>,q<rsub|1>)>|<cell|\<mapsto\>>|<cell|f<rsub|0>q<rsub|0>+f<rsub|1>q<rsub|1>>>>>>
  </equation>

  in the monomial bases <with|mode|math|{1,\<ldots\>,x<rsup|d<rsub|1>-1>},{1,\<ldots\>,x<rsup|d<rsub|0>-1>}>
  and <with|mode|math|{1,\<ldots\>,x<rsup|d<rsub|0>+d<rsub|1>-1>}>, where
  <with|mode|math|A[x]<rsub|\<less\>k>> denotes the set of polynomials in
  <with|mode|math|A[x]> of degree lower or equal to <with|mode|math|k-1>.\ 

  <\proposition>
    <label|ker>If <with|mode|math|A> is a field, then we have the equality
    <with|mode|math|dim ker (S)=deg(gcd(f<rsub|0>,f<rsub|1>))>.
  </proposition>

  <\definition>
    \ The resultant of the polynomials <with|mode|math|f<rsub|0>> and
    <with|mode|math|f<rsub|1>>, denoted <with|mode|math|R*e*s(f<rsub|0>,f<rsub|1>)>,
    is the determinant of the Sylvester matrix of <with|mode|math|f<rsub|0>>
    and <with|mode|math|f<rsub|1>>\ 
  </definition>

  The resultant <with|mode|math|Res(f<rsub|0>,f<rsub|1>)> is thus an element
  in <with|mode|math|A>. It has been widely studied in the literature, since
  it provides a way to eliminate the variable <with|mode|math|x> from the
  polynomial system <with|mode|math|f<rsub|0>(x)=f<rsub|1>(x)=0>. Indeed,
  \ we have

  <\proposition>
    <label|sylvres><with|mode|math|Res(f<rsub|0>,f<rsub|1>)=0> if and only if
    either <with|mode|math|c<rsub|0,d<rsub|0>>=c<rsub|1,d<rsub|1>>=0>, or
    either <with|mode|math|f<rsub|0>(x)> and <with|mode|math|f<rsub|1>(x)>
    have a common root in the algebraic closure of the fraction field
    <with|mode|math|F> of <with|mode|math|A> (or equivalently
    <with|mode|math|f<rsub|0>> and <with|mode|math|f<rsub|1>> are not coprime
    in <with|mode|math|F[x]>).
  </proposition>

  See: <verbatim|synaps/upol/resultant.h>

  <subsection|The Bezout matrix>

  Another matrix, called the Bezoutian matrix, can be used to compute
  <with|mode|math|Res(f<rsub|0>,f<rsub|1>)>. We now suppose w.l.o.g. that
  <with|mode|math|d<rsub|1>\<geq\>d<rsub|0>>.\ 

  <\definition>
    \ The Bezoutian of the polynomials <with|mode|math|f<rsub|0>> and
    <with|mode|math|f<rsub|1>> is the element in <with|mode|math|A[x,y]>
    defined by

    <\equation*>
      \<Theta\><rsub|f<rsub|0>,f<rsub|1>>(x,y):=<frac|f<rsub|0>(x)f<rsub|1>(y)-f<rsub|1>(x)f<rsub|0>(y)|x-y>=<big|sum><rsub|i,j=0><rsup|d<rsub|1>-1>\<theta\><rsub|i,j>x<rsup|i>y<rsup|j>
    </equation*>

    and the Bezout matrix is <with|mode|math|B<rsub|f<rsub|0>,f<rsub|1>>:=<left|(>\<theta\><rsub|i,j><right|)><rsub|0\<leq\>i,j\<leq\>d<rsub|1>-1>>.
  </definition>

  \ The matrix <with|mode|math|B<rsub|f<rsub|0>,f<rsub|1>>> is a
  <with|mode|math|d\<times\>d<rsub|>>-matrix which is symmetric:\ 

  <\equation*>
    B<rsub|f<rsub|0>,f<rsub|1>>=<left|[><tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|c>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|-1|3|3|cell-halign|c>|<cwith|1|-1|4|4|cell-halign|c>|<table|<row|<cell|\<theta\><rsup|f<rsub|0>,f<rsub|1>><rsub|0,0>>|<cell|\<cdots\>>|<cell|\<theta\><rsup|f<rsub|0>,f<rsub|1>><rsub|0,d-1>>>|<row|<cell|\<vdots\>>|<cell|>|<cell|\<vdots\>>>|<row|<cell|\<theta\><rsup|f<rsub|0>,f<rsub|1>><rsub|d<rsub|>-1,0>>|<cell|\<cdots\>>|<cell|\<theta\><rsup|f<rsub|0>,f<rsub|1>><rsub|d-1,d-1>>>>>><right|]>
  </equation*>

  where <with|mode|math|d=max(d<rsub|1>,d<rsub|0>)>
  (<with|mode|math|=d<rsub|1>>here).

  \;

  It is thus a smaller matrix than the Sylvester matrix, but has more
  complicated entries, and its determinant still equals the resultant of
  <with|mode|math|f<rsub|0>> and <with|mode|math|f<rsub|1>> (up to a power of
  <with|mode|math|c<rsub|1,d<rsub|1>>>):

  <\proposition>
    <cite|Kra95> <label|re>We have:

    <\eqnarray*>
      <tformat|<table|<row|<cell|det(B<rsub|f<rsub|0>,f<rsub|1>>)>|<cell|=>|<cell|(-1)<rsup|<frac|1|2>d<rsub|1>(d<rsub|1>-1)><space|0.25spc>(c<rsub|1,d<rsub|1>>)<rsup|d<rsub|1>-d<rsub|0>>
      Res(f<rsub|0>,f<rsub|1>).>>>>
    </eqnarray*>

    Moreover, if <with|mode|math|A> is a field
    <with|mode|math|<with|math-font-family|rm|dim><space|0.25spc>ker(B<rsub|f<rsub|0>,f<rsub|1>>)=deg(gcd(f<rsub|0>,f<rsub|1>)).>
  </proposition>

  \;

  See: <verbatim|synaps/upol/resultant.h>

  <subsection|Example>

  <\code>
    #include \<less\>synaps/upol.h\<gtr\>

    #include \<less\>synaps/linalg/MatrDse.h\<gtr\>

    #include \<less\>synaps/upol/resultant.h\<gtr\>

    typedef UPolDse\<less\>double\<gtr\> \ upol_t

    typedef MatrDse\<less\>double\<gtr\> \ matr_t;

    using std::cout; using std::endl;

    int main (int argc, char **argv)

    {

    \ \ using std::cout; using std::endl;

    \ \ upol_t p0("3*x0+3;"); double u1[]={2,0,-1,1};upol_t p1(u1,u1+4);

    \ \ cout \<less\>\<less\>"p0 \ \ \ \ \ \ \ ="\<less\>\<less\>p0\<less\>\<less\>endl\<less\>\<less\>"p1
    \ \ \ \ \ \ \ ="\<less\>\<less\>p1\<less\>\<less\>endl;
  </code>

  <\equation*>
    p0=3 x+3 , \ \ p1=x<rsup|3>-x<rsup|2>+2
  </equation*>

  <\code>
    \ \ matrix_t S = sylvester\<less\>matr_t\<gtr\>(p0,p1); cout
    \<less\>\<less\>S\<less\>\<less\>endl;
  </code>

  <\equation*>
    <left|[><tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|c>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|-1|3|3|cell-halign|c>|<cwith|1|-1|4|4|cell-halign|c>|<table|<row|<cell|3>|<cell|0>|<cell|0>|<cell|2>>|<row|<cell|3>|<cell|3>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|3>|<cell|3>|<cell|-1>>|<row|<cell|0>|<cell|0>|<cell|3>|<cell|1>>>>><right|]>
  </equation*>

  <\code>
    \ \ matrix_t B = bezout\<less\>matr_t\<gtr\>(p0,p1); \ \ \ cout
    \<less\>\<less\>B\<less\>\<less\>endl;
  </code>

  <\equation*>
    <left|[><tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|c>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|-1|3|3|cell-halign|c>|<table|<row|<cell|-6>|<cell|-3>|<cell|3>>|<row|<cell|-3>|<cell|0>|<cell|3>>|<row|<cell|3>|<cell|3>|<cell|0>>>>><right|]>
  </equation*>

  <\code>
    \ \ B = companion\<less\>matr_t\<gtr\>(p1); \ \ \ \ \ \ \ \ cout
    \<less\>\<less\>B\<less\>\<less\>endl;
  </code>

  <\equation*>
    <left|[><tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|c>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|-1|3|3|cell-halign|c>|<table|<row|<cell|0>|<cell|0>|<cell|-2>>|<row|<cell|1>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|1>|<cell|1>>>>><right|]>
  </equation*>

  <\code>
    }
  </code>
</body>

<\references>
  <\collection>
    <associate| compagnon|<tuple|1.1|?>>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|auto-4|<tuple|1.3|?>>
    <associate|auto-5|<tuple|1.4|?>>
    <associate|auto-6|<tuple|1.4|?>>
    <associate|auto-7|<tuple|1.4|?>>
    <associate|auto-8|<tuple|1.5|?>>
    <associate|auto-9|<tuple|1.5|?>>
    <associate|compagnon|<tuple|1.1|?>>
    <associate|idx-1|<tuple|1|?>>
    <associate|idx-2|<tuple|1|?>>
    <associate|ker|<tuple|1|?>>
    <associate|phi|<tuple|1|?>>
    <associate|re|<tuple|5|?>>
    <associate|sylvester|<tuple|1.2|?>>
    <associate|sylvres|<tuple|3|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.2|?>>
    <associate|toc-4|<tuple|1.3|?>>
    <associate|toc-5|<tuple|1.4|?>>
    <associate|ubezout|<tuple|1.3|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|bib>
      Lang02

      Kra95
    </associate>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Sylvester
      and Bezout matrices> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>The compagnon matrix
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>The sylvester matrix
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>The Bezout
      matrix<label|ubezout> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>
    </associate>
  </collection>
</auxiliary>