#define USING_NAMESPACE_SYNAPS 1

#include "synaps/bignum.h"
#include "synaps/upol.h"
#include "synaps/upol/SturmSeq.h"

using std::cout;
using std::cin;
using std::endl;

#ifdef SYNAPS_WITH_GMP
typedef ZZ XX;
typedef UPolDse<XX> Upol;
#endif //SYNAPS_WITH_GMP

int main (int argc,char**argv)
{
#ifdef SYNAPS_WITH_GMP
  Upol p("5*x0^4-30*x0^3+2*x0^2-x0+2");

//   SturmSeq<XX> s(p,diff(p),STD());
//   cout <<s<<endl;

  SturmSeq<XX> s1(p,diff(p),HABICHT());
  cout <<s1<<endl;

  SturmSeq<XX> s2(p,diff(p),EUCLIDEAN());
  cout <<s2<<endl;

  SturmSeq<XX> s3(p,diff(p),REDUCED());
  cout <<s3<<endl;

  SturmSeq<XX> s4(p,diff(p),SUBRES());
  cout <<s4<<endl;

  cout <<variation(s1,double(0))<<endl;
  cout <<variation(s2,double(2))<<endl;

  //  cout << Solve(p,Sturm_solver<XX>())<<endl;
  return 0;

#else 
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
#endif //SYNAPS_WITH_GMP
}
 
