<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Univariate Aberth Solver>

  This is a connection to the C-implementation <verbatim|mpsolve> by D. Bini
  and G. Fiorentino for solving univariate polynomials. See [3] for more
  details.\ 

  The type of output of the method is specified by the parameter type of
  <verbatim|Aberth>. If <verbatim|Aberth\<less\>CC\<gtr\>> is used, it
  computes the complex solutions. If <verbatim|Aberth\<less\>RR\<gtr\>> is
  used, only the real roots are output. The result is a sequence of numbers

  <\quote-env>
    <\code>
      Seq\<less\>CC\<gtr\> sc = solve(p, Aberth\<less\>CC\<gtr\>());

      Seq\<less\>RR\<gtr\> sr = solve(p, Aberth\<less\>RR\<gtr\>());
    </code>
  </quote-env>

  Both methods accept as parameter the output precision for the roots and the
  input precision for the \ coefficients:

  <\quote-env>
    <\code>
      Aberth(16); \ \ \ \ 

      \ \ \ //Output precision of 16 digits on the roots.\ 

      \ \ \ //Input coefficients are supposed to be exact.

      Aberth(16,32); \ 

      \ \ //Precision of 16 digits on the roots and 32 on the coefficients.
    </code>
  </quote-env>

  <subsection|Implementation>

  See <verbatim|synaps/usolve/Aberth.h>

  <subsection|Example>

  <action|<with|mode|math|\<boxdot\>>|Aberth.cc>
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-10|<tuple|3.1|?>>
    <associate|auto-11|<tuple|3.2|?>>
    <associate|auto-12|<tuple|3.2|?>>
    <associate|auto-13|<tuple|4.1|?>>
    <associate|auto-14|<tuple|4.2|?>>
    <associate|auto-15|<tuple|4.2|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|auto-4|<tuple|2.1|?>>
    <associate|auto-5|<tuple|2.2|?>>
    <associate|auto-6|<tuple|3.1|?>>
    <associate|auto-7|<tuple|3.2|?>>
    <associate|auto-8|<tuple|3.2|?>>
    <associate|auto-9|<tuple|3|?>>
    <associate|toc-1|<tuple|1|1>>
    <associate|toc-10|<tuple|1.4.1|?>>
    <associate|toc-11|<tuple|1.5|?>>
    <associate|toc-2|<tuple|1.1|1>>
    <associate|toc-3|<tuple|1.1.1|1>>
    <associate|toc-4|<tuple|1.2|1>>
    <associate|toc-5|<tuple|1|?>>
    <associate|toc-6|<tuple|1.2.1|?>>
    <associate|toc-7|<tuple|1.3|?>>
    <associate|toc-8|<tuple|1.3.1|?>>
    <associate|toc-9|<tuple|1.4|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Univariate
      Aberth Solver> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>