<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Univariate Exclusion Solver>

  The methods of this family are based on a test which answers either

  <\itemize>
    <item>there is no root in the domain,

    <item>or it is unknown.
  </itemize>

  If we are in the first case, we remove the interval. Otherwise, the
  interval is splitted into two subintervals, to which we apply the test
  recursively, until a given precision is reached. Consequently, the
  remaining sub-domains might contain a root, but not guaranty is provided at
  this step.

  The test implemented in thi exclusion solver uses the function

  <\equation*>
    \<Delta\><rsub|f> (x<rsub|0>, t) =\|f(x<rsub|0>)\|
    -<big|sum><rsub|i=0><rsup|deg(f)> <frac|\|f<rsup|(k)>(x<rsub|0>)\||k!>
    t<rsup|k>.
  </equation*>

  We check that if <with|mode|math|\<Delta\><rsub|f>(x<rsub|0>,r)\<gtr\>0>,
  the interval <with|mode|math|[x<rsub|0>-r,x<rsub|0>+r]> does not contain a
  root of <with|mode|math|f>, and thus can be removed. The corresponding
  function is

  <\quote-env>
    <\code>
      Seq\<less\>double\<gtr\> solve(f,Exclusion(),a,b);
    </code>
  </quote-env>

  It returns a sequence of type \ <verbatim|Seq\<less\>C\<gtr\>>, where
  <verbatim|C> is the type of the interval bounds <verbatim|a,b>.

  <subsection|Implementation>

  See: <verbatim|synaps/usolve/Exclusion.h>

  \;
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-10|<tuple|3.1|?>>
    <associate|auto-11|<tuple|3.2|?>>
    <associate|auto-12|<tuple|3.2|?>>
    <associate|auto-13|<tuple|4.1|?>>
    <associate|auto-14|<tuple|4.2|?>>
    <associate|auto-15|<tuple|4.2|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|2|?>>
    <associate|auto-4|<tuple|2.1|?>>
    <associate|auto-5|<tuple|2.2|?>>
    <associate|auto-6|<tuple|3.1|?>>
    <associate|auto-7|<tuple|3.2|?>>
    <associate|auto-8|<tuple|3.2|?>>
    <associate|auto-9|<tuple|3|?>>
    <associate|toc-1|<tuple|1|1>>
    <associate|toc-10|<tuple|1.4.1|?>>
    <associate|toc-11|<tuple|1.5|?>>
    <associate|toc-2|<tuple|1.1|1>>
    <associate|toc-3|<tuple|1.1.1|1>>
    <associate|toc-4|<tuple|1.2|1>>
    <associate|toc-5|<tuple|1|?>>
    <associate|toc-6|<tuple|1.2.1|?>>
    <associate|toc-7|<tuple|1.3|?>>
    <associate|toc-8|<tuple|1.3.1|?>>
    <associate|toc-9|<tuple|1.4|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Univariate
      Exclusion Solver> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>
    </associate>
  </collection>
</auxiliary>