

#ifndef SYNAPS_ALGEBRAIC_KERNEL_2_H
#define SYNAPS_ALGEBRAIC_KERNEL_2_H


#include <synaps/config.h>
#include <synaps/init.h>
#include <synaps/arithm/root_of.h>
#include <synaps/bignum.h>


#include <synaps/arithm/algebraic/AK/global_functions_2.h>
#include <synaps/arithm/algebraic/AK/function_objects_2.h>


__BEGIN_NAMESPACE_SYNAPS


template < typename NT,
	   template <class> class SolverType = Small_degree >
//	   typename SolverType = Small_degree<NT> >
struct Algebraic_kernel_2 
{
  typedef Algebraic_kernel_2<NT, SolverType>             Self;
  typedef SolverType<NT>                         Solver_type;
  


  typedef typename Solver_type::RT     RT;
  typedef typename Solver_type::FT     FT;
  typedef typename Solver_type::RO_t   Root_of_2;

  typedef typename Solver_type::MPoly_2_2
  Polynomial_for_circles_2_2;
   
  typedef typename Solver_type::MPoly_2_2
  Polynomial_1_2;


  typedef SYNAPSi::Construct_polynomial_circle_2_2<Self>   Construct_polynomial_circle_2_2;
  typedef SYNAPSi::Solve<Self>                             Solve;
  

  Construct_polynomial_circle_2_2
  construct_polynomial_circle_2_2_object() const
  {
    return Construct_polynomial_circle_2_2();
  }


  Solve
  solve_object() const 
  {
    return Solve();
  }
  

};

__END_NAMESPACE_SYNAPS


namespace CGAL
{
  template < typename RT >
  double 
  to_double( const SYNAPS::ALGEBRAIC::root_of<RT>& r)
  {
    return SYNAPS::ALGEBRAIC::to_double(r);
  }


 
  template < typename RT >
  bool
  is_valid( const SYNAPS::ALGEBRAIC::root_of<RT>& r)
  {
    return SYNAPS::ALGEBRAIC::is_valid(r);
  }
 
  
 
  template < typename RT >
  typename SYNAPS::ALGEBRAIC::root_of<RT>
  square( const SYNAPS::ALGEBRAIC::root_of<RT>& r)
  {
    return SYNAPS::ALGEBRAIC::square<RT>(r);
  }

} // namespace CGAL

#endif // SYNAPS_ALGEBRAIC_KERNEL_2_H
