// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     University of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)


#ifndef SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_AUTO_RESULTS_HH
#define SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_AUTO_RESULTS_HH

#include <synaps/usolve/algebraic/Algebraic_config.h>

__ALGEBRAIC_BEGIN_NAMESPACE
int to_CR(int i);
__ALGEBRAIC_END_NAMESPACE

#include <synaps/usolve/algebraic/comparison/auto/Result_length_3.h>
#include <synaps/usolve/algebraic/comparison/auto/Result_length_4.h>
#include <synaps/usolve/algebraic/comparison/auto/Result_length_5.h>
#include <synaps/usolve/algebraic/comparison/auto/Result_length_6.h>

#include <synaps/usolve/algebraic/comparison/auto/Result_deg_length_2.h>
#include <synaps/usolve/algebraic/comparison/auto/Result_deg_length_3.h>
#include <synaps/usolve/algebraic/comparison/auto/Result_deg_length_4.h>
#include <synaps/usolve/algebraic/comparison/auto/Result_deg_length_5.h>

__ALGEBRAIC_BEGIN_NAMESPACE
struct Result_length_3;
struct Result_length_4;
struct Result_length_5;
struct Result_length_6;
class Static_Result
{
public:
static Result_length_3 Result_3;
static Result_length_4 Result_4;
static Result_length_5 Result_5;
static Result_length_6 Result_6;
};
__ALGEBRAIC_END_NAMESPACE


#endif // SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_AUTO_RESULTS_HH


