
#ifndef SYNAPS_SOLVE_SOLVER_BASE_H_
#define SYNAPS_SOLVE_SOLVER_BASE_H_

#include <synaps/init.h>
#include <synaps/upol/UPolDse.h>
#include <synaps/arithm/Interval.h>


__BEGIN_NAMESPACE_SYNAPS


struct solver_base 
{
  typedef double           RT;   ///< Ring number type
  typedef double           FT;   ///< Filed number type
  typedef double           XT;   ///< Approximate number type (if any)

  typedef Interval<FT>     FIT;  ///< Interval over FT
  typedef Interval<XT>     XIT;  ///< Interval over XT
  
  
  typedef UPolDse<RT>      Poly;    ///< Polynomial with ring number type coeffs
  typedef UPolDse<FT>      FT_Poly; ///< Polynomial with field number type coeffs
  

  typedef double           solution_type;  ///< The solution type. 
                                           ///< The solver should return this type 


  typedef solver_base      self_t;

protected:
  //! Protected constructor so that nonone can construct such an object
  solver_base() { }
  
};

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_SOLVE_SOLVER_BASE_H_
